diff -pruN 1.0.2-2/AUTHORS.rst 1.0.5-1/AUTHORS.rst
--- 1.0.2-2/AUTHORS.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/AUTHORS.rst	2020-03-03 02:59:56.000000000 +0000
@@ -30,7 +30,6 @@ The following individuals have contribut
 * Matt Dudys
 * Joakim Lundborg
 * Federico Scrinzi
-* Chris Rosenthal
 * Shane StClair
 * raistlin7447
 * Alex Dergachev
@@ -74,3 +73,23 @@ The following individuals have contribut
 * Sam Stuck
 * Edward Betts
 * Jake Zimmerman
+* Bryan Rankin
+* Przemek Wesołek
+* Karl Fogel
+* sterlingpetersen
+* kjedamzik
+* John Vandenberg
+* Olivier Lacan
+* Adrien Delessert
+* Ghislain Antony Vaillant
+* Forest Gregg
+* Aliaksei Urbanski
+* Reid Beels
+* Rodrigo Lemos
+* Victor Noagbodji
+* Connor McArthur
+* Matěj Cepl
+* Nicholas Matteo
+* Matt Giguere
+* Felix Bünemann
+* Андрій Орєхов
diff -pruN 1.0.2-2/CHANGELOG.rst 1.0.5-1/CHANGELOG.rst
--- 1.0.2-2/CHANGELOG.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/CHANGELOG.rst	2020-03-03 02:59:56.000000000 +0000
@@ -1,3 +1,75 @@
+1.0.5 - March 2, 2020
+---------------------
+
+Changes:
+
+* Dropped Python 3.4 support (end-of-life was March 18, 2019).
+
+Improvements:
+
+* Output error message for memory error even if not :code:`--verbose`.
+
+Fixes:
+
+* Fix regression in 1.0.4, which caused numbers like ``4.5`` to be parsed as dates.
+* :doc:`/scripts/in2csv` Fix error reporting if :code:`--names` used with non-Excel file.
+
+1.0.4 - March 16, 2019
+----------------------
+
+Changes:
+
+* Dropped Python 3.3 support (end-of-life was September 29, 2017).
+
+Improvements:
+
+* :doc:`/scripts/csvsql` adds a :code:`--chunk-size` option to set the chunk size when batch inserting into a table.
+* csvkit is now tested against Python 3.7.
+
+Fixes:
+
+* :code:`--names` works with :code:`--skip-lines`.
+* Dates and datetimes without punctuation can be parsed with :code:`--date-format` and :code:`datetime-format`.
+* Error messages about column indices use 1-based numbering unless :code:`--zero` is set.
+* :doc:`/scripts/csvcut` no longer errors on :code:`--delete-empty-rows` with short rows.
+* :doc:`/scripts/csvjoin` no longer errors if given a single file.
+* :doc:`/scripts/csvsql` supports UPDATE commands.
+* :doc:`/scripts/csvstat` no longer errors on non-finite numbers.
+* :doc:`/scripts/csvstat` respects all command-line arguments when :code:`--count` is set.
+* :doc:`/scripts/in2csv` CSV-to-CSV conversion respects :code:`--linenumbers` when buffering.
+* :doc:`/scripts/in2csv` writes XLS sheets without encoding errors in Python 2.
+
+1.0.3 - March 11, 2018
+----------------------
+
+Improvements:
+
+* :doc:`/scripts/csvgrep` adds a :code:`--any-match` (:code:`-a`) flag to select rows where any column matches instead of all columns.
+* :doc:`/scripts/csvjson` no longer emits a property if its value is null.
+* :doc:`/scripts/csvjson` adds :code:`--type` and :code:`--geometry` options to emit non-Point GeoJSON features.
+* :doc:`/scripts/csvjson` adds a :code:`--no-bbox` option to disable the calculation of a bounding box.
+* :doc:`/scripts/csvjson` supports :code:`--stream` for newline-delimited GeoJSON.
+* :doc:`/scripts/csvsql` adds a :code:`--unique-constraint` option to list names of columns to include in a UNIQUE constraint.
+* :doc:`/scripts/csvsql` adds :code:`--before-insert` and :code:`--after-insert` options to run commands before and after the INSERT command.
+* :doc:`/scripts/csvpy` reports an error message if input is provided via STDIN.
+* :doc:`/scripts/in2csv` adds a :code:`--encoding-xls` option to specify the encoding of the input XLS file.
+* :doc:`/scripts/in2csv` supports :code:`--no-header-row` on XLS and XLSX files.
+* Suppress agate warning about column names not specified when using :code:`--no-header-row`.
+* Prompt the user if additional input is expected (i.e. if no input file or piped data is provided).
+* Update to `agate-excel 0.2.2 <http://agate-excel.readthedocs.io/en/0.2.2/#changelog>`_, `agate-sql 0.5.3 <http://agate-sql.readthedocs.io/en/0.5.3/#changelog>`_.
+
+Fixes:
+
+* :doc:`/scripts/csvgrep` accepts utf-8 arguments to the :code:`--match` and :code:`--regex` options in Python 2.
+* :doc:`/scripts/csvjson` streams input and output only if :code:`--snifflimit` is :code:`0`.
+* :doc:`/scripts/csvsql` sets a DECIMAL's precision and scale and a VARCHAR's length to avoid dialect-specific errors.
+* :doc:`/scripts/csvstack` no longer opens all files at once.
+* :doc:`/scripts/in2csv` respects :code:`--no-header-row` when :code:`--no-inference` is set.
+* :doc:`/scripts/in2csv` CSV-to-CSV conversion streams input and output only if :code:`--snifflimit` is :code:`0`.
+* :doc:`/scripts/in2csv` supports GeoJSON files with: ``geometry`` set to ``null``, missing Point ``coordinates``, altitude coordinate values.
+
+csvkit is no longer tested on PyPy.
+
 1.0.2 - April 28, 2017
 ----------------------
 
@@ -10,15 +82,16 @@ Improvements:
 * Add a :code:`--datetime-format` option to set a strptime datetime format string.
 * Make :code:`--blanks` a common argument across all tools.
 * :code:`-I` is the short option for :code:`--no-inference`.
-* :doc:`/scripts/csvclean`, :doc:`/scripts/csvjson`, :doc:`/scripts/csvpy` support :code:`--no-header-row`.
+* :doc:`/scripts/csvclean`, :doc:`/scripts/csvformat`, :doc:`/scripts/csvjson`, :doc:`/scripts/csvpy` support :code:`--no-header-row`.
 * :doc:`/scripts/csvclean` is faster and no longer requires exponential time in the worst case.
+* :doc:`/scripts/csvformat` supports :code:`--linenumbers` and `--zero` (no-op).
 * :doc:`/scripts/csvjoin` supports :code:`--snifflimit` and :code:`--no-inference`.
 * :doc:`/scripts/csvpy` supports :code:`--linenumbers` (no-op) and :code:`--zero` (no-op).
 * :doc:`/scripts/csvsql` adds a :code:`--prefix` option to add expressions like OR IGNORE or OR REPLACE following the INSERT keyword.
 * :doc:`/scripts/csvsql` adds a :code:`--overwrite` flag to drop any existing table with the same name before creating.
 * :doc:`/scripts/csvsql` accepts a file name for the :code:`--query` option.
 * :doc:`/scripts/csvsql` supports :code:`--linenumbers` (no-op).
-* :doc:`/scripts/csvsql` adds a :code:`--create-if-not-exists` flag to not abort if the table already exists
+* :doc:`/scripts/csvsql` adds a :code:`--create-if-not-exists` flag to not abort if the table already exists.
 * :doc:`/scripts/csvstat` adds a :code:`--freq-count` option to set the maximum number of frequent values to display.
 * :doc:`/scripts/csvstat` supports :code:`--linenumbers` (no-op).
 * :doc:`/scripts/in2csv` adds a :code:`--names` flag to print Excel sheet names.
@@ -126,8 +199,8 @@ Fixes:
 * Fix broken csvkit module documentation. (#327)
 * Fix version of openpyxl to work around encoding issue. (#391, #288)
 
-0.9.0
------
+0.9.0 - September 8, 2014
+-------------------------
 
 * Write missing sections of the tutorial. (#32)
 * Remove -q arg from sql2csv (conflicts with common flag).
@@ -149,8 +222,8 @@ Fixes:
 * Implement csvformat.
 * Fix bug causing CSVKitDictWriter to output 'utf-8' for blank fields.
 
-0.8.0
------
+0.8.0 - July 27, 2014
+---------------------
 
 * Add pnaimoli to AUTHORS.
 * Fix column specification in csvstat. (#236)
@@ -160,8 +233,8 @@ Fixes:
 * Deprecated DBF support for Python 3+.
 * Add support for Python 3.3 and 3.4 (#239)
 
-0.7.3
------
+0.7.3 - April 27, 2014
+----------------------
 
 * Fix date handling with openpyxl > 2.0 (#285)
 * Add Kristina Durivage to AUTHORS. (#243)
@@ -176,18 +249,18 @@ Fixes:
 * Add Ryan Murphy to AUTHORS.
 * Fix DBF dependency. (#270)
 
-0.7.2
------
+0.7.2 - March 24, 2014
+----------------------
 
 * Fix CHANGELOG for release.
 
-0.7.1
------
+0.7.1 - March 24, 2014
+----------------------
 
 * Fix homepage url in setup.py.
 
-0.7.0
------
+0.7.0 - March 24, 2014
+----------------------
 
 * Fix XLSX datetime normalization bug. (#223)
 * Add raistlin7447 to AUTHORS.
@@ -202,8 +275,13 @@ Fixes:
 * Use case-sensitive name for SQLAlchemy (#237)
 * Add Travis Swicegood to AUTHORS.
 
-0.6.1
------
+0.6.1 - August 20, 2013
+-----------------------
+
+* Fix CHANGELOG for release.
+
+0.6.0 - August 20, 2013
+-----------------------
 
 * Add Chris Rosenthal to AUTHORS.
 * Fix multi-file input to csvsql. (#193)
@@ -222,8 +300,8 @@ Fixes:
 * Add Shane StClair to AUTHORS file.
 * Add --no-inference support to csvsort. (#222)
 
-0.5.0
------
+0.5.0 - August 21, 2012
+-----------------------
 
 * Implement geojson support in csvjson. (#159)
 * Optimize writing of eight bit codecs. (#175)
@@ -235,8 +313,8 @@ Fixes:
 * Added Noah Hoffman to AUTHORS.
 * Make csvlook output compatible with emacs table markup. (#174)
 
-0.4.4
------
+0.4.4 - May 1, 2012
+-------------------
 
 * Add Derek Wilson to AUTHORS.
 * Add Kevin Schaul to AUTHORS.
@@ -250,7 +328,7 @@ Fixes:
 * Add Anton Ian Sipos to AUTHORS.
 * Fix broken pipe errors. (#150)
 
-0.4.3
------
+0.4.3 - February 20, 2012
+-------------------------
 
 * Begin CHANGELOG (a bit late, I'll admit).
diff -pruN 1.0.2-2/CONTRIBUTING.rst 1.0.5-1/CONTRIBUTING.rst
--- 1.0.2-2/CONTRIBUTING.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/CONTRIBUTING.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,12 +8,14 @@ Report a bug
 ------------
 
 * `Browse the open issues to check that it is not already reported <https://github.com/wireservice/csvkit/issues>`_
-* Run the csvkit tool with the :code:`-v` (:code:`--verbose`) flag
+* Run the csvkit tool (:code:`csvcut`, etc.) with the :code:`-v` (:code:`--verbose`) flag
 * Open a new issue and include:
 
-  * the csvkit command (for example, :code:`csvstat -v test.csv`)
+  * the csvkit command with the :code:`-v` (:code:`--verbose`) flag (for example, :code:`csvstat -v test.csv`)
   * the input file (rename the :code:`.csv` to :code:`.txt` for GitHub)
   * the output text (including the traceback)
+  * the csvkit version (:code:`csvcut --version`)
   * the Python version (:code:`python --version`)
+  * the operating system and version
 
 Thanks!
diff -pruN 1.0.2-2/csvkit/cli.py 1.0.5-1/csvkit/cli.py
--- 1.0.2-2/csvkit/cli.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/cli.py	2020-03-03 02:59:56.000000000 +0000
@@ -6,6 +6,7 @@ import codecs
 import gzip
 import itertools
 import sys
+import warnings
 from os.path import splitext
 
 import agate
@@ -59,7 +60,6 @@ class CSVKitUtility(object):
     description = ''
     epilog = ''
     override_flags = ''
-    buffers_input = False
 
     def __init__(self, args=None, output_file=None):
         """
@@ -111,7 +111,11 @@ class CSVKitUtility(object):
             self.input_file = self._open_input_file(self.args.input_path)
 
         try:
-            self.main()
+            with warnings.catch_warnings():
+                if getattr(self.args, 'no_header_row', None):
+                    warnings.filterwarnings(action='ignore', message='Column names not specified', module='agate')
+
+                self.main()
         finally:
             if 'f' not in self.override_flags:
                 self.input_file.close()
@@ -135,8 +139,8 @@ class CSVKitUtility(object):
 
         # Input
         if 'f' not in self.override_flags:
-            self.argparser.add_argument(metavar="FILE", nargs='?', dest='input_path',
-                                        help='The CSV file to operate on. If omitted, will accept input on STDIN.')
+            self.argparser.add_argument(metavar='FILE', nargs='?', dest='input_path',
+                                        help='The CSV file to operate on. If omitted, will accept input as piped data via STDIN.')
         if 'd' not in self.override_flags:
             self.argparser.add_argument('-d', '--delimiter', dest='delimiter',
                                         help='Delimiting character of the input CSV file.')
@@ -159,7 +163,7 @@ class CSVKitUtility(object):
             self.argparser.add_argument('-z', '--maxfieldsize', dest='field_size_limit', type=int,
                                         help='Maximum length of a single field in the input CSV file.')
         if 'e' not in self.override_flags:
-            self.argparser.add_argument('-e', '--encoding', dest='encoding', default='utf-8',
+            self.argparser.add_argument('-e', '--encoding', dest='encoding', default='utf-8-sig',
                                         help='Specify the encoding of the input CSV file.')
         if 'L' not in self.override_flags:
             self.argparser.add_argument('-L', '--locale', dest='locale', default='en_US',
@@ -181,7 +185,7 @@ class CSVKitUtility(object):
                                         help='Specify that the input CSV file has no header row. Will create default headers (a,b,c,...).')
         if 'K' not in self.override_flags:
             self.argparser.add_argument('-K', '--skip-lines', dest='skip_lines', type=int, default=0,
-                                        help='Specify the number of initial lines to skip (e.g. comments, copyright notices, empty rows).')
+                                        help='Specify the number of initial lines to skip before the header row (e.g. comments, copyright notices, empty rows).')
         if 'v' not in self.override_flags:
             self.argparser.add_argument('-v', '--verbose', dest='verbose', action='store_true',
                                         help='Print detailed tracebacks when errors occur.')
@@ -196,7 +200,7 @@ class CSVKitUtility(object):
             self.argparser.add_argument('--zero', dest='zero_based', action='store_true',
                                         help='When interpreting or displaying column numbers, use zero-based numbering instead of the default 1-based numbering.')
 
-        self.argparser.add_argument('-V', '--version', action='version', version='%(prog)s 1.0.2',
+        self.argparser.add_argument('-V', '--version', action='version', version='%(prog)s 1.0.5',
                                     help='Display version information and exit.')
 
     def _open_input_file(self, path):
@@ -204,17 +208,14 @@ class CSVKitUtility(object):
         Open the input file specified on the command line.
         """
         if six.PY2:
-            mode = 'rb'
+            mode = 'Urb'
             kwargs = {}
         else:
-            mode = 'rt'
+            mode = 'rt'  # default
             kwargs = {'encoding': self.args.encoding}
 
         if not path or path == '-':
-            if self.buffers_input:
-                f = six.StringIO(sys.stdin.read())
-            else:
-                f = sys.stdin
+            f = sys.stdin
         else:
             extension = splitext(path)[1]
 
@@ -279,9 +280,11 @@ class CSVKitUtility(object):
                 # Special case handling for Unicode errors, which behave very strangely
                 # when cast with unicode()
                 if t == UnicodeDecodeError:
-                    sys.stderr.write('Your file is not "%s" encoded. Please specify the correct encoding with the -e flag. Use the -v flag to see the complete error.\n' % self.args.encoding)
+                    sys.stderr.write('Your file is not "%s" encoded. Please specify the correct encoding with the -e '
+                                     'flag or with the PYTHONIOENCODING environment variable. Use the -v flag to see '
+                                     'the complete error.\n' % self.args.encoding)
                 else:
-                    sys.stderr.write('%s\n' % six.text_type(value))
+                    sys.stderr.write('%s: %s\n' % (t.__name__, six.text_type(value)))
 
         sys.excepthook = handler
 
@@ -291,16 +294,27 @@ class CSVKitUtility(object):
         else:
             type_kwargs = {}
 
-        types = [agate.Text(**type_kwargs)]
+        text_type = agate.Text(**type_kwargs)
+
+        if self.args.no_inference:
+            types = [text_type]
+        else:
+            number_type = agate.Number(locale=self.args.locale, **type_kwargs)
 
-        if not self.args.no_inference:
+            # See the order in the `agate.TypeTester` class.
             types = [
                 agate.Boolean(**type_kwargs),
-                agate.Number(locale=self.args.locale, **type_kwargs),
                 agate.TimeDelta(**type_kwargs),
                 agate.Date(date_format=self.args.date_format, **type_kwargs),
                 agate.DateTime(datetime_format=self.args.datetime_format, **type_kwargs),
-            ] + types
+                text_type,
+            ]
+
+            # In order to parse dates like "20010101".
+            if self.args.date_format or self.args.datetime_format:
+                types.insert(-1, number_type)
+            else:
+                types.insert(1, number_type)
 
         return agate.TypeTester(types=types)
 
@@ -351,19 +365,19 @@ class CSVKitUtility(object):
         if getattr(self.args, 'no_header_row', None):
             raise RequiredHeaderError('You cannot use --no-header-row with the -n or --names options.')
 
-        f = self.input_file
-        output = self.output_file
-
         if getattr(self.args, 'zero_based', None):
             start = 0
         else:
             start = 1
 
-        rows = agate.csv.reader(f, **self.reader_kwargs)
+        rows = agate.csv.reader(self.skip_lines(), **self.reader_kwargs)
         column_names = next(rows)
 
         for i, c in enumerate(column_names, start):
-            output.write('%3i: %s\n' % (i, c))
+            self.output_file.write('%3i: %s\n' % (i, c))
+
+    def additional_input_expected(self):
+        return sys.stdin.isatty() and not self.args.input_path
 
 
 def make_default_headers(n):
@@ -390,11 +404,11 @@ def match_column_identifier(column_names
 
         # Fail out if index is 0-based
         if c < 0:
-            raise ColumnIdentifierError("Column 0 is invalid. Columns are 1-based.")
+            raise ColumnIdentifierError("Column %i is invalid. Columns are 1-based." % (c + column_offset))
 
         # Fail out if index is out of range
         if c >= len(column_names):
-            raise ColumnIdentifierError("Column %i is invalid. The last column is '%s' at index %i." % (c, column_names[-1], len(column_names) - 1))
+            raise ColumnIdentifierError("Column %i is invalid. The last column is '%s' at index %i." % (c + column_offset, column_names[-1], len(column_names) - 1 + column_offset))
 
     return c
 
@@ -402,8 +416,8 @@ def match_column_identifier(column_names
 def parse_column_identifiers(ids, column_names, column_offset=1, excluded_columns=None):
     """
     Parse a comma-separated list of column indices AND/OR names into a list of integer indices.
-    Ranges of integers can be specified with two integers separated by a '-' or ':' character. Ranges of
-    non-integers (e.g. column names) are not supported.
+    Ranges of integers can be specified with two integers separated by a '-' or ':' character.
+    Ranges of non-integers (e.g. column names) are not supported.
     Note: Column indices are 1-based.
     """
     if not column_names:
diff -pruN 1.0.2-2/csvkit/convert/geojs.py 1.0.5-1/csvkit/convert/geojs.py
--- 1.0.2-2/csvkit/convert/geojs.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/convert/geojs.py	2020-03-03 02:59:56.000000000 +0000
@@ -42,9 +42,12 @@ def geojson2csv(f, key=None, **kwargs):
                 property_fields.append(prop)
 
         geometry = feature['geometry']
-        geometry_type = geometry.get('type')
-        if geometry_type == 'Point':
-            longitude, latitude = geometry['coordinates']
+        if geometry:
+            geometry_type = geometry.get('type')
+        else:
+            geometry_type = None
+        if geometry_type == 'Point' and 'coordinates' in geometry:
+            longitude, latitude = geometry['coordinates'][0:2]  # Drop altitude or elevation.
         else:
             longitude, latitude = (None, None)
 
diff -pruN 1.0.2-2/csvkit/grep.py 1.0.5-1/csvkit/grep.py
--- 1.0.2-2/csvkit/grep.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/grep.py	2020-03-03 02:59:56.000000000 +0000
@@ -6,7 +6,7 @@ from csvkit.exceptions import ColumnIden
 
 
 class FilteringCSVReader(six.Iterator):
-    """
+    r"""
     Given any row iterator, only return rows which pass the filter.
     If 'header' is False, then all rows must pass the filter; by default, the first row will be passed
     through untested.
diff -pruN 1.0.2-2/csvkit/utilities/csvclean.py 1.0.5-1/csvkit/utilities/csvclean.py
--- 1.0.2-2/csvkit/utilities/csvclean.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvclean.py	2020-03-03 02:59:56.000000000 +0000
@@ -18,6 +18,9 @@ class CSVClean(CSVKitUtility):
                                     help='Do not create output files. Information about what would have been done will be printed to STDERR.')
 
     def main(self):
+        if self.additional_input_expected():
+            sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
+
         reader = agate.csv.reader(self.skip_lines(), **self.reader_kwargs)
 
         if self.args.dryrun:
diff -pruN 1.0.2-2/csvkit/utilities/csvcut.py 1.0.5-1/csvkit/utilities/csvcut.py
--- 1.0.2-2/csvkit/utilities/csvcut.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvcut.py	2020-03-03 02:59:56.000000000 +0000
@@ -9,6 +9,8 @@ https://gist.github.com/561347/9846ebf8d
 Used and modified with permission.
 """
 
+import sys
+
 import agate
 
 from csvkit.cli import CSVKitUtility
@@ -22,9 +24,9 @@ class CSVCut(CSVKitUtility):
         self.argparser.add_argument('-n', '--names', dest='names_only', action='store_true',
                                     help='Display column names and indices from the input CSV and exit.')
         self.argparser.add_argument('-c', '--columns', dest='columns',
-                                    help='A comma separated list of column indices or names to be extracted. Defaults to all columns.')
+                                    help='A comma separated list of column indices, names or ranges to be extracted, e.g. "1,id,3-5". Defaults to all columns.')
         self.argparser.add_argument('-C', '--not-columns', dest='not_columns',
-                                    help='A comma separated list of column indices or names to be excluded. Defaults to no columns.')
+                                    help='A comma separated list of column indices, names or ranges to be excluded, e.g. "1,id,3-5". Defaults to no columns.')
         self.argparser.add_argument('-x', '--delete-empty-rows', dest='delete_empty', action='store_true',
                                     help='After cutting, delete rows which are completely empty.')
 
@@ -33,6 +35,9 @@ class CSVCut(CSVKitUtility):
             self.print_column_names()
             return
 
+        if self.additional_input_expected():
+            sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
+
         rows, column_names, column_ids = self.get_rows_and_column_names_and_column_ids(**self.reader_kwargs)
 
         output = agate.csv.writer(self.output_file, **self.writer_kwargs)
@@ -41,7 +46,7 @@ class CSVCut(CSVKitUtility):
         for row in rows:
             out_row = [row[column_id] if column_id < len(row) else None for column_id in column_ids]
 
-            if not self.args.delete_empty or ''.join(out_row):
+            if not self.args.delete_empty or any(out_row):
                 output.writerow(out_row)
 
 
diff -pruN 1.0.2-2/csvkit/utilities/csvformat.py 1.0.5-1/csvkit/utilities/csvformat.py
--- 1.0.2-2/csvkit/utilities/csvformat.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvformat.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,5 +1,7 @@
 #!/usr/bin/env python
 
+import sys
+
 import agate
 
 from csvkit.cli import CSVKitUtility
@@ -7,7 +9,7 @@ from csvkit.cli import CSVKitUtility
 
 class CSVFormat(CSVKitUtility):
     description = 'Convert a CSV file to a custom output format.'
-    override_flags = ['l', 'zero', 'H', 'L', 'date-format', 'datetime-format']
+    override_flags = ['L', 'blanks', 'date-format', 'datetime-format']
 
     def add_arguments(self):
         self.argparser.add_argument('-D', '--out-delimiter', dest='out_delimiter',
@@ -28,6 +30,9 @@ class CSVFormat(CSVKitUtility):
     def _extract_csv_writer_kwargs(self):
         kwargs = {}
 
+        if self.args.line_numbers:
+            kwargs['line_numbers'] = True
+
         if self.args.out_tabs:
             kwargs['delimiter'] = '\t'
         elif self.args.out_delimiter:
@@ -41,6 +46,9 @@ class CSVFormat(CSVKitUtility):
         return kwargs
 
     def main(self):
+        if self.additional_input_expected():
+            sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
+
         reader = agate.csv.reader(self.skip_lines(), **self.reader_kwargs)
         writer = agate.csv.writer(self.output_file, **self.writer_kwargs)
         writer.writerows(reader)
diff -pruN 1.0.2-2/csvkit/utilities/csvgrep.py 1.0.5-1/csvkit/utilities/csvgrep.py
--- 1.0.2-2/csvkit/utilities/csvgrep.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvgrep.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,9 +1,11 @@
 #!/usr/bin/env python
 
 import re
+import sys
 from argparse import FileType
 
 import agate
+import six
 
 from csvkit.cli import CSVKitUtility
 from csvkit.grep import FilteringCSVReader
@@ -14,24 +16,36 @@ class CSVGrep(CSVKitUtility):
     override_flags = ['L', 'blanks', 'date-format', 'datetime-format']
 
     def add_arguments(self):
+        # I feel that there ought to be a better way to do this across Python 2 and 3.
+        def option_parser(bytestring):
+            if six.PY2:
+                return bytestring.decode(sys.getfilesystemencoding())
+            else:
+                return bytestring
+
         self.argparser.add_argument('-n', '--names', dest='names_only', action='store_true',
                                     help='Display column names and indices from the input CSV and exit.')
         self.argparser.add_argument('-c', '--columns', dest='columns',
-                                    help='A comma separated list of column indices or names to be searched.')
-        self.argparser.add_argument('-m', '--match', dest="pattern", action='store',
+                                    help='A comma separated list of column indices, names or ranges to be searched, e.g. "1,id,3-5".')
+        self.argparser.add_argument('-m', '--match', dest="pattern", action='store', type=option_parser,
                                     help='The string to search for.')
-        self.argparser.add_argument('-r', '--regex', dest='regex', action='store',
+        self.argparser.add_argument('-r', '--regex', dest='regex', action='store', type=option_parser,
                                     help='If specified, must be followed by a regular expression which will be tested against the specified columns.')
         self.argparser.add_argument('-f', '--file', dest='matchfile', type=FileType('r'), action='store',
                                     help='If specified, must be the path to a file. For each tested row, if any line in the file (stripped of line separators) is an exact match for the cell value, the row will pass.')
         self.argparser.add_argument('-i', '--invert-match', dest='inverse', action='store_true',
                                     help='If specified, select non-matching instead of matching rows.')
+        self.argparser.add_argument('-a', '--any-match', dest='any_match', action='store_true',
+                                    help='If specified, select rows where any column matches instead of all columns.')
 
     def main(self):
         if self.args.names_only:
             self.print_column_names()
             return
 
+        if self.additional_input_expected():
+            sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
+
         if not self.args.columns:
             self.argparser.error('You must specify at least one column to search using the -c option.')
 
@@ -50,6 +64,7 @@ class CSVGrep(CSVKitUtility):
             pattern = re.compile(self.args.regex)
         elif self.args.matchfile:
             lines = set(line.rstrip() for line in self.args.matchfile)
+            self.args.matchfile.close()
 
             def pattern(x):
                 return x in lines
@@ -57,7 +72,7 @@ class CSVGrep(CSVKitUtility):
             pattern = self.args.pattern
 
         patterns = dict((column_id, pattern) for column_id in column_ids)
-        filter_reader = FilteringCSVReader(rows, header=False, patterns=patterns, inverse=self.args.inverse)
+        filter_reader = FilteringCSVReader(rows, header=False, patterns=patterns, inverse=self.args.inverse, any_match=self.args.any_match)
 
         output = agate.csv.writer(self.output_file, **writer_kwargs)
         output.writerow(column_names)
diff -pruN 1.0.2-2/csvkit/utilities/csvjoin.py 1.0.5-1/csvkit/utilities/csvjoin.py
--- 1.0.2-2/csvkit/utilities/csvjoin.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvjoin.py	2020-03-03 02:59:56.000000000 +0000
@@ -12,7 +12,7 @@ class CSVJoin(CSVKitUtility):
     override_flags = ['f']
 
     def add_arguments(self):
-        self.argparser.add_argument(metavar="FILE", nargs='*', dest='input_paths', default=['-'],
+        self.argparser.add_argument(metavar='FILE', nargs='*', dest='input_paths', default=['-'],
                                     help='The CSV files to operate on. If only one is specified, it will be copied to STDOUT.')
         self.argparser.add_argument('-c', '--columns', dest='columns',
                                     help='The column name(s) on which to join. Should be either one name (or index) or a comma-separated list with one name (or index) for each file, in the same order that the files were specified. May also be left unspecified, in which case the two files will be joined sequentially without performing any matching.')
@@ -33,8 +33,8 @@ class CSVJoin(CSVKitUtility):
         for path in self.args.input_paths:
             self.input_files.append(self._open_input_file(path))
 
-        if len(self.input_files) < 2:
-            self.argparser.error('You must specify at least two files to join.')
+        if len(self.input_files) < 1:
+            self.argparser.error('You must specify at least one file to join.')
 
         if self.args.columns:
             join_column_names = self._parse_join_column_names(self.args.columns)
diff -pruN 1.0.2-2/csvkit/utilities/csvjson.py 1.0.5-1/csvkit/utilities/csvjson.py
--- 1.0.2-2/csvkit/utilities/csvjson.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvjson.py	2020-03-03 02:59:56.000000000 +0000
@@ -3,6 +3,7 @@
 import codecs
 import datetime
 import decimal
+import sys
 
 try:
     from collections import OrderedDict
@@ -19,19 +20,24 @@ from csvkit.cli import CSVKitUtility, ma
 
 class CSVJSON(CSVKitUtility):
     description = 'Convert a CSV file into JSON (or GeoJSON).'
-    buffers_input = True
 
     def add_arguments(self):
-        self.argparser.add_argument('-i', '--indent', dest='indent', type=int, default=None,
+        self.argparser.add_argument('-i', '--indent', dest='indent', type=int,
                                     help='Indent the output JSON this many spaces. Disabled by default.')
-        self.argparser.add_argument('-k', '--key', dest='key', type=str, default=None,
+        self.argparser.add_argument('-k', '--key', dest='key',
                                     help='Output JSON as an array of objects keyed by a given column, KEY, rather than as a list. All values in the column must be unique. If --lat and --lon are also specified, this column will be used as GeoJSON Feature ID.')
-        self.argparser.add_argument('--lat', dest='lat', type=str, default=None,
+        self.argparser.add_argument('--lat', dest='lat',
                                     help='A column index or name containing a latitude. Output will be GeoJSON instead of JSON. Only valid if --lon is also specified.')
-        self.argparser.add_argument('--lon', dest='lon', type=str, default=None,
+        self.argparser.add_argument('--lon', dest='lon',
                                     help='A column index or name containing a longitude. Output will be GeoJSON instead of JSON. Only valid if --lat is also specified.')
-        self.argparser.add_argument('--crs', dest='crs', type=str, default=None,
+        self.argparser.add_argument('--type', dest='type',
+                                    help='A column index or name containing a GeoJSON type. Output will be GeoJSON instead of JSON. Only valid if --lat and --lon are also specified.')
+        self.argparser.add_argument('--geometry', dest='geometry',
+                                    help='A column index or name containing a GeoJSON geometry. Output will be GeoJSON instead of JSON. Only valid if --lat and --lon are also specified.')
+        self.argparser.add_argument('--crs', dest='crs',
                                     help='A coordinate reference system string to be included with GeoJSON output. Only valid if --lat and --lon are also specified.')
+        self.argparser.add_argument('--no-bbox', dest='no_bbox', action='store_true',
+                                    help='Disable the calculation of a bounding box.')
         self.argparser.add_argument('--stream', dest='streamOutput', action='store_true',
                                     help='Output JSON as a stream of newline-separated objects, rather than an as an array.')
         self.argparser.add_argument('-y', '--snifflimit', dest='sniff_limit', type=int,
@@ -39,21 +45,47 @@ class CSVJSON(CSVKitUtility):
         self.argparser.add_argument('-I', '--no-inference', dest='no_inference', action='store_true',
                                     help='Disable type inference (and --locale, --date-format, --datetime-format) when parsing CSV input.')
 
-    def main(self):
-        # We need to do this dance here, because we aren't writing through agate.
-        if six.PY2:
-            stream = codecs.getwriter('utf-8')(self.output_file)
-        else:
-            stream = self.output_file
+    def __init__(self, args=None, output_file=None):
+        super(CSVJSON, self).__init__(args, output_file)
 
-        json_kwargs = {
+        self.validate_args()
+
+        self.json_kwargs = {
             'ensure_ascii': False,
             'indent': self.args.indent,
         }
 
+        # We need to do this stream dance here, because we aren't writing through agate.
         if six.PY2:
-            json_kwargs['encoding'] = 'utf-8'
+            self.stream = codecs.getwriter('utf-8')(self.output_file)
+            self.json_kwargs['encoding'] = 'utf-8'
+        else:
+            self.stream = self.output_file
+
+    def main(self):
+        """
+        Convert CSV to JSON.
+        """
+
+        if self.can_stream():
+            if self.additional_input_expected():
+                sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
 
+            if self.is_geo():
+                self.streaming_output_ndgeojson()
+            else:
+                self.streaming_output_ndjson()
+
+        else:
+            if self.additional_input_expected():
+                self.argparser.error('You must provide an input file or piped data.')
+
+            if self.is_geo():
+                self.output_geojson()
+            else:
+                self.output_json()
+
+    def dump_json(self, data, newline=False):
         def default(obj):
             if isinstance(obj, (datetime.date, datetime.datetime)):
                 return obj.isoformat()
@@ -61,134 +93,207 @@ class CSVJSON(CSVKitUtility):
                 return str(obj)
             raise TypeError('%s is not JSON serializable' % repr(obj))
 
-        def dump_json(data, newline=False):
-            json.dump(data, stream, default=default, **json_kwargs)
-            if newline:
-                stream.write("\n")
+        json.dump(data, self.stream, default=default, **self.json_kwargs)
+        if newline:
+            self.stream.write("\n")
 
-        """
-        Convert CSV to JSON.
-        """
+    def can_stream(self):
+        return self.args.streamOutput and self.args.no_inference and self.args.sniff_limit == 0 and not self.args.skip_lines
+
+    def is_geo(self):
+        return self.args.lat and self.args.lon
+
+    def validate_args(self):
         if self.args.lat and not self.args.lon:
             self.argparser.error('--lon is required whenever --lat is specified.')
-
         if self.args.lon and not self.args.lat:
             self.argparser.error('--lat is required whenever --lon is specified.')
 
         if self.args.crs and not self.args.lat:
             self.argparser.error('--crs is only allowed when --lat and --lon are also specified.')
+        if self.args.type and not self.args.lat:
+            self.argparser.error('--type is only allowed when --lat and --lon are also specified.')
+        if self.args.geometry and not self.args.lat:
+            self.argparser.error('--geometry is only allowed when --lat and --lon are also specified.')
+
+        if self.args.key and self.args.streamOutput and not (self.args.lat and self.args.lon):
+            self.argparser.error('--key is only allowed with --stream when --lat and --lon are also specified.')
+
+    def read_csv_to_table(self):
+        return agate.Table.from_csv(
+            self.input_file,
+            skip_lines=self.args.skip_lines,
+            sniff_limit=self.args.sniff_limit,
+            column_types=self.get_column_types(),
+            **self.reader_kwargs
+        )
+
+    def output_json(self):
+        self.read_csv_to_table().to_json(
+            self.output_file,
+            key=self.args.key,
+            newline=self.args.streamOutput,
+            indent=self.args.indent,
+        )
+
+    def output_geojson(self):
+        table = self.read_csv_to_table()
+        geojson_generator = self.GeoJsonGenerator(self.args, table.column_names)
 
-        if self.args.streamOutput and (self.args.lat or self.args.lon or self.args.key):
-            self.argparser.error('--stream is only allowed if --lat, --lon and --key are not specified.')
+        if self.args.streamOutput:
+            for row in table.rows:
+                self.dump_json(geojson_generator.feature_for_row(row), newline=True)
+        else:
+            self.dump_json(geojson_generator.generate_feature_collection(table))
 
-        # GeoJSON
-        if self.args.lat and self.args.lon:
-            table = agate.Table.from_csv(
-                self.input_file,
-                skip_lines=self.args.skip_lines,
-                sniff_limit=self.args.sniff_limit,
-                column_types=self.get_column_types(),
-                **self.reader_kwargs
-            )
+    def streaming_output_ndjson(self):
+        rows = agate.csv.reader(self.input_file, **self.reader_kwargs)
+        column_names = next(rows)
+
+        for row in rows:
+            data = OrderedDict()
+            for i, column in enumerate(column_names):
+                try:
+                    data[column] = row[i]
+                except IndexError:
+                    data[column] = None
+            self.dump_json(data, newline=True)
+
+    def streaming_output_ndgeojson(self):
+        rows = agate.csv.reader(self.input_file, **self.reader_kwargs)
+        column_names = next(rows)
+        geojson_generator = self.GeoJsonGenerator(self.args, column_names)
+
+        for row in rows:
+            self.dump_json(geojson_generator.feature_for_row(row), newline=True)
+
+    class GeoJsonGenerator:
+        def __init__(self, args, column_names):
+            self.args = args
+            self.column_names = column_names
 
-            features = []
-            min_lon = None
-            min_lat = None
-            max_lon = None
-            max_lat = None
+            self.lat_column = match_column_identifier(column_names, self.args.lat, self.args.zero_based)
 
-            lat_column = match_column_identifier(table.column_names, self.args.lat, self.args.zero_based)
-            lon_column = match_column_identifier(table.column_names, self.args.lon, self.args.zero_based)
+            self.lon_column = match_column_identifier(column_names, self.args.lon, self.args.zero_based)
+
+            if self.args.type:
+                self.type_column = match_column_identifier(column_names, self.args.type, self.args.zero_based)
+            else:
+                self.type_column = None
+
+            if self.args.geometry:
+                self.geometry_column = match_column_identifier(column_names, self.args.geometry, self.args.zero_based)
+            else:
+                self.geometry_column = None
 
             if self.args.key:
-                id_column = match_column_identifier(table.column_names, self.args.key, self.args.zero_based)
+                self.id_column = match_column_identifier(column_names, self.args.key, self.args.zero_based)
             else:
-                id_column = None
+                self.id_column = None
+
+        def generate_feature_collection(self, table):
+            features = []
+            bounds = self.GeoJsonBounds()
 
             for row in table.rows:
-                feature = OrderedDict()
-                feature['type'] = 'Feature'
-                properties = OrderedDict()
-                geoid = None
-                lat = None
-                lon = None
-
-                for i, c in enumerate(row):
-                    if i == lat_column:
-                        try:
-                            lat = float(c)
-                        except ValueError:
-                            lat = None
-                        if min_lat is None or lat < min_lat:
-                            min_lat = lat
-                        if max_lat is None or lat > max_lat:
-                            max_lat = lat
-                    elif i == lon_column:
-                        try:
-                            lon = float(c)
-                        except ValueError:
-                            lon = None
-                        if min_lon is None or lon < min_lon:
-                            min_lon = lon
-                        if max_lon is None or lon > max_lon:
-                            max_lon = lon
-                    elif i == id_column:
-                        geoid = c
-                    else:
-                        properties[table.column_names[i]] = c
+                feature = self.feature_for_row(row)
 
-                if id_column is not None:
-                    feature['id'] = geoid
+                if not self.args.no_bbox:
+                    bounds.add_feature(feature)
 
-                feature['geometry'] = OrderedDict([
-                    ('type', 'Point'),
-                    ('coordinates', [lon, lat])
-                ])
-                feature['properties'] = properties
                 features.append(feature)
 
-            output = OrderedDict([
+            items = [
                 ('type', 'FeatureCollection'),
-                ('bbox', [min_lon, min_lat, max_lon, max_lat]),
-                ('features', features)
-            ])
+                ('features', features),
+            ]
+
+            if not self.args.no_bbox:
+                items.insert(1, ('bbox', bounds.bbox()))
 
             if self.args.crs:
-                output['crs'] = OrderedDict([
+                items.append(('crs', OrderedDict([
                     ('type', 'name'),
                     ('properties', {
-                        'name': self.args.crs
-                    })
+                        'name': self.args.crs,
+                    }),
+                ])))
+
+            return OrderedDict(items)
+
+        def feature_for_row(self, row):
+            feature = OrderedDict([
+                ('type', 'Feature'),
+                ('properties', OrderedDict()),
+            ])
+
+            for i, c in enumerate(row):
+                # Prevent "type" or geo fields from being added to properties.
+                if c is None or i in (self.type_column, self.lat_column, self.lon_column, self.geometry_column):
+                    continue
+                elif i == self.id_column:
+                    feature['id'] = c
+                elif c:
+                    feature['properties'][self.column_names[i]] = c
+
+            feature['geometry'] = self.geometry_for_row(row)
+
+            return feature
+
+        def geometry_for_row(self, row):
+            lat = None
+            lon = None
+
+            if self.geometry_column is not None:
+                return json.loads(row[self.geometry_column])
+
+            if self.lat_column is not None and self.lon_column is not None:
+                try:
+                    lon = float(row[self.lon_column])
+                    lat = float(row[self.lat_column])
+                except ValueError:
+                    lon = None
+                    lat = None
+
+            if lon and lat:
+                return OrderedDict([
+                    ('type', 'Point'),
+                    ('coordinates', [lon, lat]),
                 ])
 
-            dump_json(output)
-        elif self.args.streamOutput and self.args.no_inference and not self.args.skip_lines:
-            rows = agate.csv.reader(self.input_file, **self.reader_kwargs)
-            column_names = next(rows)
-
-            for row in rows:
-                data = OrderedDict()
-                for i, column in enumerate(column_names):
-                    try:
-                        data[column] = row[i]
-                    except IndexError:
-                        data[column] = None
-                dump_json(data, newline=True)
-        else:
-            table = agate.Table.from_csv(
-                self.input_file,
-                skip_lines=self.args.skip_lines,
-                sniff_limit=self.args.sniff_limit,
-                column_types=self.get_column_types(),
-                **self.reader_kwargs
-            )
-
-            table.to_json(
-                self.output_file,
-                key=self.args.key,
-                newline=self.args.streamOutput,
-                indent=self.args.indent
-            )
+        class GeoJsonBounds:
+            def __init__(self):
+                self.min_lon = None
+                self.min_lat = None
+                self.max_lon = None
+                self.max_lat = None
+
+            def bbox(self):
+                return [self.min_lon, self.min_lat, self.max_lon, self.max_lat]
+
+            def add_feature(self, feature):
+                if 'geometry' in feature and 'coordinates' in feature['geometry']:
+                    self.update_coordinates(feature['geometry']['coordinates'])
+
+            def update_lat(self, lat):
+                if self.min_lat is None or lat < self.min_lat:
+                    self.min_lat = lat
+                if self.max_lat is None or lat > self.max_lat:
+                    self.max_lat = lat
+
+            def update_lon(self, lon):
+                if self.min_lon is None or lon < self.min_lon:
+                    self.min_lon = lon
+                if self.max_lon is None or lon > self.max_lon:
+                    self.max_lon = lon
+
+            def update_coordinates(self, coordinates):
+                if len(coordinates) <= 3 and isinstance(coordinates[0], (float, int)):
+                    self.update_lon(coordinates[0])
+                    self.update_lat(coordinates[1])
+                else:
+                    for coordinate in coordinates:
+                        self.update_coordinates(coordinate)
 
 
 def launch_new_instance():
diff -pruN 1.0.2-2/csvkit/utilities/csvlook.py 1.0.5-1/csvkit/utilities/csvlook.py
--- 1.0.2-2/csvkit/utilities/csvlook.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvlook.py	2020-03-03 02:59:56.000000000 +0000
@@ -7,7 +7,6 @@ from csvkit.cli import CSVKitUtility
 
 class CSVLook(CSVKitUtility):
     description = 'Render a CSV file in the console as a Markdown-compatible, fixed-width table.'
-    buffers_input = True
 
     def add_arguments(self):
         self.argparser.add_argument('--max-rows', dest='max_rows', type=int,
@@ -22,6 +21,9 @@ class CSVLook(CSVKitUtility):
                                     help='Disable type inference when parsing the input.')
 
     def main(self):
+        if self.additional_input_expected():
+            self.argparser.error('You must provide an input file or piped data.')
+
         table = agate.Table.from_csv(
             self.input_file,
             skip_lines=self.args.skip_lines,
diff -pruN 1.0.2-2/csvkit/utilities/csvpy.py 1.0.5-1/csvkit/utilities/csvpy.py
--- 1.0.2-2/csvkit/utilities/csvpy.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvpy.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,5 +1,7 @@
 #!/usr/bin/env python
 
+import sys
+
 import agate
 
 from csvkit.cli import CSVKitUtility
@@ -15,6 +17,9 @@ class CSVPy(CSVKitUtility):
                                     help='Load the CSV file into an agate table.')
 
     def main(self):
+        if self.input_file == sys.stdin:
+            self.argparser.error('csvpy cannot accept input as piped data via STDIN.')
+
         # Attempt reading filename, will cause lazy loader to access file and raise error if it does not exist
         filename = self.input_file.name
 
diff -pruN 1.0.2-2/csvkit/utilities/csvsort.py 1.0.5-1/csvkit/utilities/csvsort.py
--- 1.0.2-2/csvkit/utilities/csvsort.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvsort.py	2020-03-03 02:59:56.000000000 +0000
@@ -7,13 +7,12 @@ from csvkit.cli import CSVKitUtility, pa
 
 class CSVSort(CSVKitUtility):
     description = 'Sort CSV files. Like the Unix "sort" command, but for tabular data.'
-    buffers_input = True
 
     def add_arguments(self):
         self.argparser.add_argument('-n', '--names', dest='names_only', action='store_true',
                                     help='Display column names and indices from the input CSV and exit.')
         self.argparser.add_argument('-c', '--columns', dest='columns',
-                                    help='A comma separated list of column indices or names to sort by. Defaults to all columns.')
+                                    help='A comma separated list of column indices, names or ranges to sort by, e.g. "1,id,3-5". Defaults to all columns.')
         self.argparser.add_argument('-r', '--reverse', dest='reverse', action='store_true',
                                     help='Sort in descending order.')
         self.argparser.add_argument('-y', '--snifflimit', dest='sniff_limit', type=int,
@@ -26,6 +25,9 @@ class CSVSort(CSVKitUtility):
             self.print_column_names()
             return
 
+        if self.additional_input_expected():
+            self.argparser.error('You must provide an input file or piped data.')
+
         table = agate.Table.from_csv(
             self.input_file,
             skip_lines=self.args.skip_lines,
diff -pruN 1.0.2-2/csvkit/utilities/csvsql.py 1.0.5-1/csvkit/utilities/csvsql.py
--- 1.0.2-2/csvkit/utilities/csvsql.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvsql.py	2020-03-03 02:59:56.000000000 +0000
@@ -19,43 +19,56 @@ class CSVSQL(CSVKitUtility):
     override_flags = ['f']
 
     def add_arguments(self):
-
-        self.argparser.add_argument(metavar="FILE", nargs='*', dest='input_paths', default=['-'],
-                                    help='The CSV file(s) to operate on. If omitted, will accept input on STDIN.')
+        self.argparser.add_argument(metavar='FILE', nargs='*', dest='input_paths', default=['-'],
+                                    help='The CSV file(s) to operate on. If omitted, will accept input as piped data via STDIN.')
         self.argparser.add_argument('-i', '--dialect', dest='dialect', choices=DIALECTS,
                                     help='Dialect of SQL to generate. Only valid when --db is not specified.')
         self.argparser.add_argument('--db', dest='connection_string',
-                                    help='If present, a sqlalchemy connection string to use to directly execute generated SQL on a database.')
-        self.argparser.add_argument('--query', default=None,
-                                    help='Execute one or more SQL queries delimited by ";" and output the result of the last query as CSV.')
+                                    help='If present, a SQLAlchemy connection string to use to directly execute generated SQL on a database.')
+        self.argparser.add_argument('--query',
+                                    help='Execute one or more SQL queries delimited by ";" and output the result of the last query as CSV. QUERY may be a filename.')
         self.argparser.add_argument('--insert', dest='insert', action='store_true',
                                     help='In addition to creating the table, also insert the data into the table. Only valid when --db is specified.')
         self.argparser.add_argument('--prefix', action='append', default=[],
                                     help='Add an expression following the INSERT keyword, like OR IGNORE or OR REPLACE.')
+        self.argparser.add_argument('--before-insert', dest='before_insert',
+                                    help='Execute SQL before the INSERT command.')
+        self.argparser.add_argument('--after-insert', dest='after_insert',
+                                    help='Execute SQL after the INSERT command.')
         self.argparser.add_argument('--tables', dest='table_names',
-                                    help='Specify the names of the tables to be created. By default, the tables will be named after the filenames without extensions or "stdin".')
+                                    help='A comma-separated list of names of tables to be created. By default, the tables will be named after the filenames without extensions or "stdin".')
         self.argparser.add_argument('--no-constraints', dest='no_constraints', action='store_true',
                                     help='Generate a schema without length limits or null checks. Useful when sampling big tables.')
+        self.argparser.add_argument('--unique-constraint', dest='unique_constraint',
+                                    help='A column-separated list of names of columns to include in a UNIQUE constraint.')
         self.argparser.add_argument('--no-create', dest='no_create', action='store_true',
                                     help='Skip creating a table. Only valid when --insert is specified.')
         self.argparser.add_argument('--create-if-not-exists', dest='create_if_not_exists', action='store_true',
                                     help='Create table if it does not exist, otherwise keep going. Only valid when --insert is specified.')
         self.argparser.add_argument('--overwrite', dest='overwrite', action='store_true',
-                                    help='Drop the table before creating.')
+                                    help='Drop the table before creating. Only valid when --insert is specified and --no-create is not specified.')
         self.argparser.add_argument('--db-schema', dest='db_schema',
                                     help='Optional name of database schema to create table(s) in.')
         self.argparser.add_argument('-y', '--snifflimit', dest='sniff_limit', type=int,
                                     help='Limit CSV dialect sniffing to the specified number of bytes. Specify "0" to disable sniffing entirely.')
         self.argparser.add_argument('-I', '--no-inference', dest='no_inference', action='store_true',
                                     help='Disable type inference when parsing the input.')
+        self.argparser.add_argument('--chunk-size', dest='chunk_size', type=int,
+                                    help='Chunk size for batch insert into the table. Only valid when --insert is specified.')
 
     def main(self):
+        if sys.stdin.isatty() and not self.args.input_paths:
+            self.argparser.error('You must provide an input file or piped data.')
+
         self.input_files = []
         self.connection = None
         self.table_names = []
+        self.unique_constraint = []
 
         if self.args.table_names:
             self.table_names = self.args.table_names.split(',')
+        if self.args.unique_constraint:
+            self.unique_constraint = self.args.unique_constraint.split(',')
 
         # Create an SQLite database in memory if no connection string is specified
         if self.args.query and not self.args.connection_string:
@@ -64,15 +77,23 @@ class CSVSQL(CSVKitUtility):
 
         if self.args.dialect and self.args.connection_string:
             self.argparser.error('The --dialect option is only valid when neither --db nor --query are specified.')
-
         if self.args.insert and not self.args.connection_string:
             self.argparser.error('The --insert option is only valid when either --db or --query is specified.')
 
         if self.args.no_create and not self.args.insert:
             self.argparser.error('The --no-create option is only valid if --insert is also specified.')
-
         if self.args.create_if_not_exists and not self.args.insert:
             self.argparser.error('The --create-if-not-exists option is only valid if --insert is also specified.')
+        if self.args.overwrite and not self.args.insert:
+            self.argparser.error('The --overwrite option is only valid if --insert is also specified.')
+        if self.args.overwrite and self.args.no_create:
+            self.argparser.error('The --overwrite option is only valid if --no-create is not specified.')
+        if self.args.before_insert and not self.args.insert:
+            self.argparser.error('The --before-insert option is only valid if --insert is also specified.')
+        if self.args.after_insert and not self.args.insert:
+            self.argparser.error('The --after-insert option is only valid if --insert is also specified.')
+        if self.args.chunk_size and not self.args.insert:
+            self.argparser.error('The --chunk-size option is only valid if --insert is also specified.')
 
         if self.args.no_create and self.args.create_if_not_exists:
             self.argparser.error('The --no-create and --create-if-not-exists options are mutually exclusive.')
@@ -86,7 +107,7 @@ class CSVSQL(CSVKitUtility):
             try:
                 engine = create_engine(self.args.connection_string)
             except ImportError:
-                raise ImportError('You don\'t appear to have the necessary database backend installed for connection string you\'re trying to use. Available backends include:\n\nPostgresql:\tpip install psycopg2\nMySQL:\t\tpip install MySQL-python\n\nFor details on connection strings and other backends, please see the SQLAlchemy documentation on dialects at: \n\nhttp://www.sqlalchemy.org/docs/dialects/\n\n')
+                raise ImportError('You don\'t appear to have the necessary database backend installed for connection string you\'re trying to use. Available backends include:\n\nPostgresql:\tpip install psycopg2\nMySQL:\t\tpip install mysql-connector-python\n\nFor details on connection strings and other backends, please see the SQLAlchemy documentation on dialects at: \n\nhttp://www.sqlalchemy.org/docs/dialects/\n\n')
 
             self.connection = engine.connect()
 
@@ -135,6 +156,10 @@ class CSVSQL(CSVKitUtility):
 
             if table:
                 if self.connection:
+                    if self.args.before_insert:
+                        for query in self.args.before_insert.split(';'):
+                            self.connection.execute(query)
+
                     table.to_sql(
                         self.connection,
                         table_name,
@@ -144,16 +169,23 @@ class CSVSQL(CSVKitUtility):
                         insert=self.args.insert and len(table.rows) > 0,
                         prefixes=self.args.prefix,
                         db_schema=self.args.db_schema,
-                        constraints=not self.args.no_constraints
+                        constraints=not self.args.no_constraints,
+                        unique_constraint=self.unique_constraint,
+                        chunk_size=self.args.chunk_size
                     )
 
+                    if self.args.after_insert:
+                        for query in self.args.after_insert.split(';'):
+                            self.connection.execute(query)
+
                 # Output SQL statements
                 else:
                     statement = table.to_sql_create_statement(
                         table_name,
                         dialect=self.args.dialect,
                         db_schema=self.args.db_schema,
-                        constraints=not self.args.no_constraints
+                        constraints=not self.args.no_constraints,
+                        unique_constraint=self.unique_constraint
                     )
 
                     self.output_file.write('%s\n' % statement)
@@ -166,7 +198,7 @@ class CSVSQL(CSVKitUtility):
                 else:
                     query = self.args.query
 
-                # Execute the specified SQL queries
+                # Execute the specified SQL queries.
                 queries = query.split(';')
                 rows = None
 
@@ -175,10 +207,11 @@ class CSVSQL(CSVKitUtility):
                         rows = self.connection.execute(q)
 
                 # Output the result of the last query as CSV
-                output = agate.csv.writer(self.output_file, **self.writer_kwargs)
-                output.writerow(rows._metadata.keys)
-                for row in rows:
-                    output.writerow(row)
+                if rows.returns_rows:
+                    output = agate.csv.writer(self.output_file, **self.writer_kwargs)
+                    output.writerow(rows._metadata.keys)
+                    for row in rows:
+                        output.writerow(row)
 
             transaction.commit()
 
diff -pruN 1.0.2-2/csvkit/utilities/csvstack.py 1.0.5-1/csvkit/utilities/csvstack.py
--- 1.0.2-2/csvkit/utilities/csvstack.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvstack.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,6 +1,7 @@
 #!/usr/bin/env python
 
 import os.path
+import sys
 
 import agate
 
@@ -8,13 +9,13 @@ from csvkit.cli import CSVKitUtility, ma
 
 
 class CSVStack(CSVKitUtility):
-    description = 'Stack up the rows from multiple CSV files, optionally adding a grouping value.'
+    description = 'Stack up the rows from multiple CSV files, optionally adding a grouping value. Files are assumed to have the same columns in the same order.'
     # Override 'f' because the utility accepts multiple files.
     override_flags = ['f', 'L', 'blanks', 'date-format', 'datetime-format']
 
     def add_arguments(self):
-        self.argparser.add_argument(metavar="FILE", nargs='+', dest='input_paths', default=['-'],
-                                    help='The CSV file(s) to operate on. If omitted, will accept input on STDIN.')
+        self.argparser.add_argument(metavar='FILE', nargs='*', dest='input_paths', default=['-'],
+                                    help='The CSV file(s) to operate on. If omitted, will accept input as piped data via STDIN.')
         self.argparser.add_argument('-g', '--groups', dest='groups',
                                     help='A comma-separated list of values to add as "grouping factors", one for each CSV being stacked. These will be added to the stacked CSV as a new column. You may specify a name for the grouping column using the -n flag.')
         self.argparser.add_argument('-n', '--group-name', dest='group_name',
@@ -23,20 +24,15 @@ class CSVStack(CSVKitUtility):
                                     help='Use the filename of each input file as its grouping value. When specified, -g will be ignored.')
 
     def main(self):
-        self.input_files = []
+        if sys.stdin.isatty() and not self.args.input_paths:
+            sys.stderr.write('No input file or piped data provided. Waiting for standard input:\n')
 
-        for path in self.args.input_paths:
-            self.input_files.append(self._open_input_file(path))
+        has_groups = self.args.groups is not None or self.args.group_by_filenames
 
-        if not self.input_files:
-            self.argparser.error('You must specify at least one file to stack.')
-
-        if self.args.group_by_filenames:
-            groups = [os.path.basename(f.name) for f in self.input_files]
-        elif self.args.groups:
+        if self.args.groups is not None and not self.args.group_by_filenames:
             groups = self.args.groups.split(',')
 
-            if len(groups) != len(self.input_files):
+            if len(groups) != len(self.args.input_paths):
                 self.argparser.error('The number of grouping values must be equal to the number of CSV files being stacked.')
         else:
             groups = None
@@ -45,7 +41,9 @@ class CSVStack(CSVKitUtility):
 
         output = agate.csv.writer(self.output_file, **self.writer_kwargs)
 
-        for i, f in enumerate(self.input_files):
+        for i, path in enumerate(self.args.input_paths):
+            f = self._open_input_file(path)
+
             if isinstance(self.args.skip_lines, int):
                 skip_lines = self.args.skip_lines
                 while skip_lines > 0:
@@ -56,12 +54,18 @@ class CSVStack(CSVKitUtility):
 
             rows = agate.csv.reader(f, **self.reader_kwargs)
 
+            if has_groups:
+                if groups:
+                    group = groups[i]
+                else:
+                    group = os.path.basename(f.name)
+
             # If we have header rows, use them
             if not self.args.no_header_row:
                 headers = next(rows, [])
 
                 if i == 0:
-                    if groups:
+                    if has_groups:
                         headers.insert(0, group_name)
 
                     output.writerow(headers)
@@ -72,19 +76,19 @@ class CSVStack(CSVKitUtility):
                 headers = make_default_headers(len(row))
 
                 if i == 0:
-                    if groups:
+                    if has_groups:
                         headers.insert(0, group_name)
 
                     output.writerow(headers)
 
-                if groups:
-                    row.insert(0, groups[i])
+                if has_groups:
+                    row.insert(0, group)
 
                 output.writerow(row)
 
             for row in rows:
-                if groups:
-                    row.insert(0, groups[i])
+                if has_groups:
+                    row.insert(0, group)
 
                 output.writerow(row)
 
diff -pruN 1.0.2-2/csvkit/utilities/csvstat.py 1.0.5-1/csvkit/utilities/csvstat.py
--- 1.0.2-2/csvkit/utilities/csvstat.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/csvstat.py	2020-03-03 02:59:56.000000000 +0000
@@ -71,7 +71,7 @@ class CSVStat(CSVKitUtility):
         self.argparser.add_argument('-n', '--names', dest='names_only', action='store_true',
                                     help='Display column names and indices from the input CSV and exit.')
         self.argparser.add_argument('-c', '--columns', dest='columns',
-                                    help='A comma separated list of column indices or names to be examined. Defaults to all columns.')
+                                    help='A comma separated list of column indices, names or ranges to be examined, e.g. "1,id,3-5". Defaults to all columns.')
         self.argparser.add_argument('--type', dest='type_only', action='store_true',
                                     help='Only output data type.')
         self.argparser.add_argument('--nulls', dest='nulls_only', action='store_true',
@@ -106,6 +106,9 @@ class CSVStat(CSVKitUtility):
             self.print_column_names()
             return
 
+        if self.additional_input_expected():
+            self.argparser.error('You must provide an input file or piped data.')
+
         operations = [op for op in OPERATIONS.keys() if getattr(self.args, op + '_only')]
 
         if len(operations) > 1:
@@ -121,7 +124,7 @@ class CSVStat(CSVKitUtility):
             self.output_file = codecs.getwriter('utf-8')(self.output_file)
 
         if self.args.count_only:
-            count = len(list(agate.csv.reader(self.input_file)))
+            count = len(list(agate.csv.reader(self.skip_lines(), **self.reader_kwargs)))
 
             if not self.args.no_header_row:
                 count -= 1
@@ -168,6 +171,9 @@ class CSVStat(CSVKitUtility):
             else:
                 self.print_stats(table, column_ids, stats)
 
+    def is_finite_decimal(self, value):
+        return isinstance(value, Decimal) and value.is_finite()
+
     def print_one(self, table, column_id, operation, label=True, **kwargs):
         """
         Print data for a single statistic.
@@ -187,7 +193,7 @@ class CSVStat(CSVKitUtility):
                     op = OPERATIONS[op_name]['aggregation']
                     stat = table.aggregate(op(column_id))
 
-                    if isinstance(stat, Decimal):
+                    if self.is_finite_decimal(stat):
                         stat = format_decimal(stat, locale=agate.config.get_option('default_locale'))
             except:
                 stat = None
@@ -221,8 +227,8 @@ class CSVStat(CSVKitUtility):
                         op = op_data['aggregation']
                         v = table.aggregate(op(column_id))
 
-                        if isinstance(v, Decimal):
-                            v = format_decimal(v)
+                        if self.is_finite_decimal(v):
+                            v = format_decimal(v, locale=agate.config.get_option('default_locale'))
 
                         stats[op_name] = v
                 except:
@@ -265,8 +271,8 @@ class CSVStat(CSVKitUtility):
                         if isinstance(column.data_type, agate.Number):
                             v = row[column_name]
 
-                            if isinstance(v, Decimal):
-                                v = format_decimal(v)
+                            if self.is_finite_decimal(v):
+                                v = format_decimal(v, locale=agate.config.get_option('default_locale'))
                         else:
                             v = six.text_type(row[column_name])
 
diff -pruN 1.0.2-2/csvkit/utilities/in2csv.py 1.0.5-1/csvkit/utilities/in2csv.py
--- 1.0.2-2/csvkit/utilities/in2csv.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/in2csv.py	2020-03-03 02:59:56.000000000 +0000
@@ -32,8 +32,8 @@ class In2CSV(CSVKitUtility):
             else:
                 return bytestring
 
-        self.argparser.add_argument(metavar="FILE", nargs='?', dest='input_path',
-                                    help='The CSV file to operate on. If omitted, will accept input on STDIN.')
+        self.argparser.add_argument(metavar='FILE', nargs='?', dest='input_path',
+                                    help='The CSV file to operate on. If omitted, will accept input as piped data via STDIN.')
         self.argparser.add_argument('-f', '--format', dest='filetype',
                                     help='The format of the input file. If not specified will be inferred from the file type. Supported formats: %s.' % ', '.join(sorted(SUPPORTED_FORMATS)))
         self.argparser.add_argument('-s', '--schema', dest='schema',
@@ -46,6 +46,8 @@ class In2CSV(CSVKitUtility):
                                     help='The name of the Excel sheet to operate on.')
         self.argparser.add_argument('--write-sheets', dest='write_sheets', type=option_parser,
                                     help='The names of the Excel sheets to write to files, or "-" to write all sheets.')
+        self.argparser.add_argument('--encoding-xls', dest='encoding_xls',
+                                    help='Specify the encoding of the input XLS file.')
         self.argparser.add_argument('-y', '--snifflimit', dest='sniff_limit', type=int,
                                     help='Limit CSV dialect sniffing to the specified number of bytes. Specify "0" to disable sniffing entirely.')
         self.argparser.add_argument('-I', '--no-inference', dest='no_inference', action='store_true',
@@ -60,11 +62,14 @@ class In2CSV(CSVKitUtility):
         else:
             return open(path, 'rb')
 
-    def sheet_names(self, filetype):
+    def sheet_names(self, path, filetype):
+        input_file = self.open_excel_input_file(path)
         if filetype == 'xls':
-            return xlrd.open_workbook(file_contents=self.input_file.read()).sheet_names()
-        elif filetype == 'xlsx':
-            return openpyxl.load_workbook(self.input_file, read_only=True, data_only=True).sheetnames
+            sheet_names = xlrd.open_workbook(file_contents=input_file.read()).sheet_names()
+        else:  # 'xlsx'
+            sheet_names = openpyxl.load_workbook(input_file, read_only=True, data_only=True).sheetnames
+        input_file.close()
+        return sheet_names
 
     def main(self):
         path = self.args.input_path
@@ -80,30 +85,26 @@ class In2CSV(CSVKitUtility):
             filetype = 'json'
         else:
             if not path or path == '-':
-                self.argparser.error('You must specify a format when providing data via STDIN (pipe).')
+                self.argparser.error('You must specify a format when providing input as piped data via STDIN.')
             filetype = convert.guess_format(path)
             if not filetype:
                 self.argparser.error('Unable to automatically determine the format of the input file. Try specifying a format with --format.')
 
-        # Buffer standard input if the input file is in CSV format or if performing type inference.
-        self.buffers_input = filetype == 'csv' or not self.args.no_inference
-
-        # Set the input file.
-        if filetype in ('xls', 'xlsx'):
-            self.input_file = self.open_excel_input_file(path)
-        else:
-            self.input_file = self._open_input_file(path)
-
         if self.args.names_only:
-            sheets = self.sheet_names(filetype)
-            if sheets:
+            if filetype in ('xls', 'xlsx'):
+                sheets = self.sheet_names(path, filetype)
                 for sheet in sheets:
                     self.output_file.write('%s\n' % sheet)
             else:
                 self.argparser.error('You cannot use the -n or --names options with non-Excel files.')
-            self.input_file.close()
             return
 
+        # Set the input file.
+        if filetype in ('xls', 'xlsx'):
+            self.input_file = self.open_excel_input_file(path)
+        else:
+            self.input_file = self._open_input_file(path)
+
         # Set the reader's arguments.
         kwargs = {}
 
@@ -116,14 +117,17 @@ class In2CSV(CSVKitUtility):
             kwargs.update(self.reader_kwargs)
             kwargs['sniff_limit'] = self.args.sniff_limit
 
-        if filetype not in ('dbf', 'geojson', 'json', 'ndjson'):
+        if filetype in ('xls', 'xlsx'):
+            kwargs['header'] = not self.args.no_header_row
+
+        if filetype not in ('dbf', 'geojson', 'json', 'ndjson'):  # csv, fixed, xls, xlsx
             kwargs['skip_lines'] = self.args.skip_lines
 
         if filetype != 'dbf':
             kwargs['column_types'] = self.get_column_types()
 
         # Convert the file.
-        if filetype == 'csv' and self.args.no_inference and not self.args.skip_lines:
+        if filetype == 'csv' and self.args.no_inference and not self.args.no_header_row and not self.args.skip_lines and self.args.sniff_limit == 0:
             reader = agate.csv.reader(self.input_file, **self.reader_kwargs)
             writer = agate.csv.writer(self.output_file, **self.writer_kwargs)
             writer.writerows(reader)
@@ -139,14 +143,14 @@ class In2CSV(CSVKitUtility):
             elif filetype == 'ndjson':
                 table = agate.Table.from_json(self.input_file, key=self.args.key, newline=True, **kwargs)
             elif filetype == 'xls':
-                table = agate.Table.from_xls(self.input_file, sheet=self.args.sheet, **kwargs)
+                table = agate.Table.from_xls(self.input_file, sheet=self.args.sheet, encoding_override=self.args.encoding_xls, **kwargs)
             elif filetype == 'xlsx':
                 table = agate.Table.from_xlsx(self.input_file, sheet=self.args.sheet, **kwargs)
             elif filetype == 'dbf':
                 if not hasattr(self.input_file, 'name'):
                     raise ValueError('DBF files can not be converted from stdin. You must pass a filename.')
                 table = agate.Table.from_dbf(self.input_file.name, **kwargs)
-            table.to_csv(self.output_file)
+            table.to_csv(self.output_file, **self.writer_kwargs)
 
         if self.args.write_sheets:
             # Close and re-open the file, as the file object has been mutated or closed.
@@ -155,19 +159,19 @@ class In2CSV(CSVKitUtility):
             self.input_file = self.open_excel_input_file(path)
 
             if self.args.write_sheets == '-':
-                sheets = self.sheet_names(filetype)
+                sheets = self.sheet_names(path, filetype)
             else:
                 sheets = [int(sheet) if sheet.isdigit() else sheet for sheet in self.args.write_sheets.split(',')]
 
             if filetype == 'xls':
-                tables = agate.Table.from_xls(self.input_file, sheet=sheets, **kwargs)
+                tables = agate.Table.from_xls(self.input_file, sheet=sheets, encoding_override=self.args.encoding_xls, **kwargs)
             elif filetype == 'xlsx':
                 tables = agate.Table.from_xlsx(self.input_file, sheet=sheets, **kwargs)
 
             base = splitext(self.input_file.name)[0]
             for i, table in enumerate(tables.values()):
                 with open('%s_%d.csv' % (base, i), 'w') as f:
-                    table.to_csv(f)
+                    table.to_csv(f, **self.writer_kwargs)
 
         self.input_file.close()
 
diff -pruN 1.0.2-2/csvkit/utilities/sql2csv.py 1.0.5-1/csvkit/utilities/sql2csv.py
--- 1.0.2-2/csvkit/utilities/sql2csv.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/csvkit/utilities/sql2csv.py	2020-03-03 02:59:56.000000000 +0000
@@ -14,9 +14,9 @@ class SQL2CSV(CSVKitUtility):
     def add_arguments(self):
         self.argparser.add_argument('--db', dest='connection_string', default='sqlite://',
                                     help='An sqlalchemy connection string to connect to a database.',)
-        self.argparser.add_argument(metavar="FILE", nargs='?', dest='input_path',
-                                    help='The file to use as SQL query. If both FILE and QUERY are omitted, query will be read from STDIN.')
-        self.argparser.add_argument('--query', default=None,
+        self.argparser.add_argument(metavar='FILE', nargs='?', dest='input_path',
+                                    help='The file to use as SQL query. If both FILE and QUERY are omitted, query will be read as piped data via STDIN.')
+        self.argparser.add_argument('--query',
                                     help="The SQL query to execute. If specified, it overrides FILE and STDIN.")
         self.argparser.add_argument('-e', '--encoding', dest='encoding', default='utf-8',
                                     help='Specify the encoding of the input query file.')
@@ -36,10 +36,17 @@ class SQL2CSV(CSVKitUtility):
         )
 
     def main(self):
+        if self.additional_input_expected() and not self.args.query:
+            self.argparser.error('You must provide an input file or piped data.')
+
         try:
             engine = create_engine(self.args.connection_string)
         except ImportError:
-            raise ImportError('You don\'t appear to have the necessary database backend installed for connection string you\'re trying to use. Available backends include:\n\nPostgresql:\tpip install psycopg2\nMySQL:\t\tpip install MySQL-python\n\nFor details on connection strings and other backends, please see the SQLAlchemy documentation on dialects at: \n\nhttp://www.sqlalchemy.org/docs/dialects/\n\n')
+            raise ImportError("You don't appear to have the necessary database backend installed for connection "
+                              "string you're trying to use. Available backends include:\n\nPostgreSQL:\tpip install "
+                              "psycopg2\nMySQL:\t\tpip install mysql-connector-python\n\nFor details on connection "
+                              "strings and other backends, please see the SQLAlchemy documentation on dialects at:\n\n"
+                              "http://www.sqlalchemy.org/docs/dialects/\n\n")
 
         connection = engine.connect()
 
diff -pruN 1.0.2-2/debian/changelog 1.0.5-1/debian/changelog
--- 1.0.2-2/debian/changelog	2019-11-28 07:23:57.000000000 +0000
+++ 1.0.5-1/debian/changelog	2020-08-18 06:02:12.000000000 +0000
@@ -1,3 +1,14 @@
+csvkit (1.0.5-1) unstable; urgency=medium
+
+  * Team upload.
+  * New upstream version 1.0.5
+  * Refreshing No-privacy-breach.patch.
+  * Requires python3-agatesql (>= 0.5.3).
+  * Updating debian/copyright.
+  * Adding 'Rules-Requires-Root: no'.
+
+ -- Andrius Merkys <merkys@debian.org>  Tue, 18 Aug 2020 02:02:12 -0400
+
 csvkit (1.0.2-2) unstable; urgency=medium
 
   * Team upload.
diff -pruN 1.0.2-2/debian/control 1.0.5-1/debian/control
--- 1.0.2-2/debian/control	2019-11-27 15:54:23.000000000 +0000
+++ 1.0.5-1/debian/control	2020-08-18 05:26:30.000000000 +0000
@@ -10,7 +10,7 @@ Build-Depends: debhelper (>= 11),
                python3-agate <!nocheck>,
                python3-agatedbf <!nocheck>,
                python3-agateexcel <!nocheck>,
-               python3-agatesql <!nocheck>,
+               python3-agatesql (>= 0.5.3) <!nocheck>,
                python3-all,
                python3-doc <!nodoc>,
                python3-setuptools,
@@ -22,6 +22,7 @@ Standards-Version: 4.1.3
 Vcs-Browser: https://salsa.debian.org/science-team/csvkit
 Vcs-Git: https://salsa.debian.org/science-team/csvkit.git
 Homepage: https://github.com/wireservice/csvkit
+Rules-Requires-Root: no
 
 Package: csvkit
 Architecture: all
diff -pruN 1.0.2-2/debian/copyright 1.0.5-1/debian/copyright
--- 1.0.2-2/debian/copyright	2019-11-27 15:53:43.000000000 +0000
+++ 1.0.5-1/debian/copyright	2020-08-18 05:26:00.000000000 +0000
@@ -3,12 +3,13 @@ Upstream-Name: csvkit
 Source: https://github.com/wireservice/csvkit
 
 Files: *
-Copyright: 2016 Christopher Groskopf and contributors
+Copyright: 2016, Christopher Groskopf and contributors
 License: Expat
 
 Files: debian/*
-Copyright: 2015 Sandro Tosi <morph@debian.org>
- 2018 Ghislain Antony Vaillant <ghisvail@gmail.com>
+Copyright: 2015, Sandro Tosi <morph@debian.org>
+ 2018, Ghislain Antony Vaillant <ghisvail@gmail.com>
+ 2020, Andrius Merkys <merkys@debian.org>
 License: Expat
 
 License: Expat
diff -pruN 1.0.2-2/debian/patches/No-privacy-breach.patch 1.0.5-1/debian/patches/No-privacy-breach.patch
--- 1.0.2-2/debian/patches/No-privacy-breach.patch	2019-11-27 15:53:43.000000000 +0000
+++ 1.0.5-1/debian/patches/No-privacy-breach.patch	2020-08-17 14:41:13.000000000 +0000
@@ -6,27 +6,17 @@ Subject: No privacy breach
  README.rst | 28 ----------------------------
  1 file changed, 28 deletions(-)
 
-diff --git a/README.rst b/README.rst
-index 47777fa..677ed00 100644
 --- a/README.rst
 +++ b/README.rst
-@@ -1,31 +1,3 @@
--.. image:: https://secure.travis-ci.org/wireservice/csvkit.png
+@@ -1,27 +1,3 @@
+-.. image:: https://secure.travis-ci.org/wireservice/csvkit.svg
 -    :target: https://travis-ci.org/wireservice/csvkit
 -    :alt: Build Status
 -
--.. image:: https://gemnasium.com/wireservice/csvkit.png
--    :target: https://gemnasium.com/wireservice/csvkit
--    :alt: Dependency Status
--
--.. image:: https://coveralls.io/repos/wireservice/csvkit/badge.png?branch=master
+-.. image:: https://coveralls.io/repos/wireservice/csvkit/badge.svg?branch=master
 -    :target: https://coveralls.io/r/wireservice/csvkit
 -    :alt: Coverage Status
 -
--.. image:: https://img.shields.io/pypi/dw/csvkit.svg
--    :target: https://pypi.python.org/pypi/csvkit
--    :alt: PyPI downloads
--
 -.. image:: https://img.shields.io/pypi/v/csvkit.svg
 -    :target: https://pypi.python.org/pypi/csvkit
 -    :alt: Version
@@ -39,6 +29,10 @@ index 47777fa..677ed00 100644
 -    :target: https://pypi.python.org/pypi/csvkit
 -    :alt: Support Python versions
 -
+-.. image:: https://img.shields.io/pypi/dm/csvkit.svg
+-    :target: https://pypi.python.org/pypi/csvkit
+-    :alt: Downloads per month on PyPI
+-
  csvkit is a suite of command-line tools for converting to and working with CSV, the king of tabular file formats.
  
- It is inspired by pdftk, gdal and the original csvcut tool by Joe Germuska and Aaron Bycoffe.
+ It is inspired by pdftk, GDAL and the original csvcut tool by Joe Germuska and Aaron Bycoffe.
diff -pruN 1.0.2-2/docs/cli.rst 1.0.5-1/docs/cli.rst
--- 1.0.2-2/docs/cli.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/cli.rst	2020-03-03 02:59:56.000000000 +0000
@@ -26,6 +26,15 @@ Processing
     scripts/csvsort
     scripts/csvstack
 
+To change field values (i.e. to run ``sed`` or ``awk``-like commands on CSV files), consider `miller <https://github.com/johnkerl/miller>`_ (``mlr put``).
+
+To transpose CSVs, consider `csvtool <http://colin.maudry.com/csvtool-manual-page/>`_. Install ``csvtool`` on Linux using your package manager, or on macOS using::
+
+    brew install ocaml
+    opam install csv
+    ln -s ~/.opam/system/bin/csvtool /usr/local/bin/
+    csvtool --help
+
 Output and Analysis
 ===================
 
@@ -39,7 +48,11 @@ Output and Analysis
     scripts/csvsql
     scripts/csvstat
 
-To diff CSVs, consider `daff <http://paulfitz.github.io/daff/>`_. An alternative to :doc:`csvsql` is `q <https://github.com/harelba/q>`_.
+* To draw plots, consider `jp <https://github.com/sgreben/jp>`_.
+* To diff CSVs, consider `daff <https://github.com/paulfitz/daff>`_.
+* To explore CSVs interactively, consider `VisiData <http://visidata.org>`_.
+
+Alternatives to :doc:`csvsql` are `q <https://github.com/harelba/q>`_ and `textql <https://github.com/dinedal/textql>`_.
 
 Common arguments
 ================
diff -pruN 1.0.2-2/docs/common_arguments.rst 1.0.5-1/docs/common_arguments.rst
--- 1.0.2-2/docs/common_arguments.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/common_arguments.rst	2020-03-03 02:59:56.000000000 +0000
@@ -2,7 +2,7 @@
 Arguments common to all tools
 =============================
 
-All tools which accept CSV as input share a set of common command-line arguments::
+csvkit's tools share a set of common command-line arguments. Not every argument is supported by every tool, so please check which are supported by the tool you are using with the :code:`--help` flag::
 
   -d DELIMITER, --delimiter DELIMITER
                         Delimiting character of the input CSV file.
@@ -37,10 +37,11 @@ All tools which accept CSV as input shar
                         Specify a strptime datetime format string like
                         "%m/%d/%Y %I:%M %p".
   -H, --no-header-row   Specify that the input CSV file has no header row.
-                        Will create default headers (A,B,C,...).
-  -L SKIP_LINES, --skip-lines SKIP_LINES
-                        Specify the number of initial lines to skip (e.g.
-                        comments, copyright notices, empty rows).
+                        Will create default headers (a,b,c,...).
+  -K SKIP_LINES, --skip-lines SKIP_LINES
+                        Specify the number of initial lines to skip before the
+                        header row (e.g. comments, copyright notices, empty
+                        rows).
   -v, --verbose         Print detailed tracebacks when errors occur.
   -l, --linenumbers     Insert a column of line numbers at the front of the
                         output. Useful when piping to grep or as a simple
@@ -50,7 +51,10 @@ All tools which accept CSV as input shar
                         numbering.
   -V, --version         Display version information and exit.
 
-These arguments may be used to override csvkit's default "smart" parsing of CSV files. This is frequently necessary if the input file uses a particularly unusual style of quoting or is an encoding that is not compatible with utf-8. Not every command is supported by every tool, but the majority of them are.
+These arguments can be used to override csvkit's default "smart" parsing of CSV files. This may be necessary, for example, if the input file uses a particularly unusual quoting style or has an encoding that is incompatible with UTF-8.
 
-Note that the output of csvkit's tools is always formatted with "default" formatting options. This means that when executing multiple csvkit commands (either with a pipe or via intermediary files) it is only ever necessary to specify formatting arguments the first time. (And doing so for subsequent commands will likely cause them to fail.)
+For example, to disable CSV sniffing, set :code:`--snifflimit 0` and then, if necessary, set the :code:`--delimiter` and :code:`--quotechar` options yourself. To disable type inference, add the :code:`--no-inference` flag.
 
+The output of csvkit's tools is always formatted with "default" formatting options. This means that when executing multiple csvkit commands (either with a pipe or through intermediary files) it is only ever necessary to specify these arguments the first time (and doing so for subsequent commands will likely cause them to fail).
+
+See the documentation of :doc:`/scripts/csvclean` for a description of the default formatting options.
diff -pruN 1.0.2-2/docs/conf.py 1.0.5-1/docs/conf.py
--- 1.0.2-2/docs/conf.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/conf.py	2020-03-03 02:59:56.000000000 +0000
@@ -41,9 +41,9 @@ copyright = u'2016, Christopher Groskopf
 # built documents.
 #
 # The short X.Y version.
-version = '1.0.2'
+version = '1.0.5'
 # The full version, including alpha/beta/rc tags.
-release = '1.0.2'
+release = '1.0.5'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
diff -pruN 1.0.2-2/docs/contributing.rst 1.0.5-1/docs/contributing.rst
--- 1.0.2-2/docs/contributing.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/contributing.rst	2020-03-03 02:59:56.000000000 +0000
@@ -87,13 +87,13 @@ Currently, the following tools stream:
 Currently, the following tools buffer:
 
 * :doc:`/scripts/csvjoin`
-* :doc:`/scripts/csvjson` unless ``--stream`` and ``--no-inference`` are set but ``--skip-lines`` is not
+* :doc:`/scripts/csvjson` unless :code:`--stream --no-inference --snifflimit 0` is set and :code:`--skip-lines` isn't set
 * :doc:`/scripts/csvlook`
 * :doc:`/scripts/csvpy`
 * :doc:`/scripts/csvsort`
 * :doc:`/scripts/csvsql`
 * :doc:`/scripts/csvstat`
-* :doc:`/scripts/in2csv` unless ``--format`` is ``ndjson`` and ``--no-inference`` is set, or ``--format`` is ``csv`` and ``--no-inference`` is set but ``--skip-lines`` is not
+* :doc:`/scripts/in2csv` unless :code:`--format ndjson --no-inference` is set, or unless :code:`--format csv --no-inference --snifflimit 0` is set and :code:`--no-header-row` and :code:`--skip-lines` aren't set
 
 Legalese
 ========
diff -pruN 1.0.2-2/docs/index.rst 1.0.5-1/docs/index.rst
--- 1.0.2-2/docs/index.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/index.rst	2020-03-03 02:59:56.000000000 +0000
@@ -7,6 +7,20 @@ About
 
 .. include:: ../README.rst
 
+First time? See :doc:`tutorial`.
+
+.. note::
+
+    To change the field separator, line terminator, etc. of the **output**, you must use :doc:`/scripts/csvformat`.
+
+.. note::
+
+    csvkit, by default, `sniffs <https://docs.python.org/3.5/library/csv.html#csv.Sniffer>`_ CSV formats (it deduces whether commas, tabs or spaces delimit fields, for example), and performs type inference (it converts text to numbers, dates, booleans, etc.). These features are useful and work well in most cases, but occasional errors occur. If you don't need these features, set :code:`--snifflimit 0` (:code:`-y 0`) and :code:`--no-inference` (:code:`-I`).
+
+.. note::
+
+    If you need to do more complex data analysis than csvkit can handle, use `agate <https://github.com/wireservice/agate>`_. If you need csvkit to be faster or to handle larger files, you may be reaching the limits of csvkit. Consider loading the data into SQL, or using `xsv <https://github.com/BurntSushi/xsv>`_.
+
 Why csvkit?
 ===========
 
diff -pruN 1.0.2-2/docs/release.rst 1.0.5-1/docs/release.rst
--- 1.0.2-2/docs/release.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/release.rst	2020-03-03 02:59:56.000000000 +0000
@@ -5,11 +5,11 @@ Release process
 #. Verify no `high priority issues <https://github.com/wireservice/csvkit/issues?q=is%3Aopen+is%3Aissue+label%3A%22High+Priority%22>`_ are outstanding.
 #. Run the full test suite with fresh environments for all versions: ``tox -r`` (Everything MUST pass.)
 #. Ensure these files all have the correct version number:
-    * CHANGELOG
+    * CHANGELOG.rst
     * setup.py
-    * csvkit/cli.py
     * docs/conf.py
-#. Tag the release: ``git tag -a x.y.z; git push --tags``
+    * csvkit/cli.py
+#. Tag the release: ``git tag -a x.y.z -m 'x.y.z release.'; git push --tags``
 #. Roll out to PyPI: ``python setup.py sdist upload``
 #. Iterate the version number in all files where it is specified. (see list above)
 #. Flag the new version for building on `Read the Docs <https://readthedocs.org/dashboard/csvkit/versions/>`_. 
diff -pruN 1.0.2-2/docs/scripts/csvclean.rst 1.0.5-1/docs/scripts/csvclean.rst
--- 1.0.2-2/docs/scripts/csvclean.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvclean.rst	2020-03-03 02:59:56.000000000 +0000
@@ -14,22 +14,22 @@ Note that every csvkit tool does the fol
 
 * removes optional quote characters, unless the `--quoting` (`-u`) option is set to change this behavior
 * changes the field delimiter to a comma, if the input delimiter is set with the `--delimiter` (`-d`) or `--tabs` (`-t`) options
-* changes the record delimiter to a line feed
+* changes the record delimiter to a line feed (LF or ``\n``)
 * changes the quote character to a double-quotation mark, if the character is set with the `--quotechar` (`-q`) option
 * changes the character encoding to UTF-8, if the input encoding is set with the `--encoding` (`-e`) option
 
 Outputs [basename]_out.csv and [basename]_err.csv, the former containing all valid rows and the latter containing all error rows along with line numbers and descriptions::
 
     usage: csvclean [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                    [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-v]
-                    [-l] [--zero] [-V] [-n]
+                    [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
+                    [-K SKIP_LINES] [-v] [-l] [--zero] [-V] [-n]
                     [FILE]
 
     Fix common errors in a CSV file.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -47,3 +47,7 @@ Test a file with known bad rows::
 
     Line 1: Expected 3 columns, found 4 columns
     Line 2: Expected 3 columns, found 2 columns
+
+To change the line ending from line feed (LF or ``\n``) to carriage return and line feed (CRLF or ``\r\n``) use::
+
+    csvformat -M $'\r\n' examples/dummy.csv
diff -pruN 1.0.2-2/docs/scripts/csvcut.rst 1.0.5-1/docs/scripts/csvcut.rst
--- 1.0.2-2/docs/scripts/csvcut.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvcut.rst	2020-03-03 02:59:56.000000000 +0000
@@ -9,7 +9,8 @@ Filters and truncates CSV files. Like th
 
     usage: csvcut [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                  [-v] [-l] [--zero] [-V] [-n] [-c COLUMNS] [-C NOT_COLUMNS] [-x]
+                  [-K SKIP_LINES] [-v] [-l] [--zero] [-V] [-n] [-c COLUMNS]
+                  [-C NOT_COLUMNS] [-x]
                   [FILE]
 
     Filter and truncate CSV files. Like the Unix "cut" command, but for tabular
@@ -17,18 +18,20 @@ Filters and truncates CSV files. Like th
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
       -n, --names           Display column names and indices from the input CSV
                             and exit.
       -c COLUMNS, --columns COLUMNS
-                            A comma separated list of column indices or names to
-                            be extracted. Defaults to all columns.
+                            A comma separated list of column indices, names or
+                            ranges to be extracted, e.g. "1,id,3-5". Defaults to
+                            all columns.
       -C NOT_COLUMNS, --not-columns NOT_COLUMNS
-                            A comma separated list of column indices or names to
-                            be excluded. Defaults to no columns.
+                            A comma separated list of column indices, names or
+                            ranges to be excluded, e.g. "1,id,3-5". Defaults to no
+                            columns.
       -x, --delete-empty-rows
                             After cutting, delete rows which are completely empty.
 
@@ -38,6 +41,10 @@ See also: :doc:`../common_arguments`.
 
     csvcut does not implement row filtering, for this you should pipe data to :doc:`csvgrep`.
 
+.. note::
+
+    If a data row is longer than the header row, its additional columns are truncated. Use :doc:`csvclean` first to fix such rows.
+
 Examples
 ========
 
@@ -55,6 +62,19 @@ Print the indices and names of all colum
       9: TOTAL
      10: 
 
+Print only the names of all columns, by removing the indices with the :code:`cut` command::
+
+    csvcut -n examples/realdata/FY09_EDU_Recipients_by_State.csv | cut -c6-
+    State Name
+    State Abbreviate
+    Code
+    Montgomery GI Bill-Active Duty
+    Montgomery GI Bill- Selective Reserve
+    Dependents' Educational Assistance
+    Reserve Educational Assistance Program
+    Post-Vietnam Era Veteran's Educational Assistance Program
+    TOTAL
+
 Extract the first and third columns::
 
     csvcut -c 1,3 examples/realdata/FY09_EDU_Recipients_by_State.csv
@@ -76,3 +96,6 @@ Display a column's unique values::
 
     csvcut -c 1 examples/realdata/FY09_EDU_Recipients_by_State.csv | sed 1d | sort | uniq
 
+Or::
+
+    csvcut -c 1 examples/realdata/FY09_EDU_Recipients_by_State.csv | csvsql --query 'SELECT DISTINCT("State Name") FROM stdin'
diff -pruN 1.0.2-2/docs/scripts/csvformat.rst 1.0.5-1/docs/scripts/csvformat.rst
--- 1.0.2-2/docs/scripts/csvformat.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvformat.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,9 +8,9 @@ Description
 Convert a CSV file to a custom output format.::
 
     usage: csvformat [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                     [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-v]
-                     [-V] [-D OUT_DELIMITER] [-T] [-Q OUT_QUOTECHAR]
-                     [-U {0,1,2,3}] [-B] [-P OUT_ESCAPECHAR]
+                     [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S]
+                     [--blanks] [-K SKIP_LINES] [-v] [-V] [-D OUT_DELIMITER] [-T]
+                     [-Q OUT_QUOTECHAR] [-U {0,1,2,3}] [-B] [-P OUT_ESCAPECHAR]
                      [-M OUT_LINETERMINATOR]
                      [FILE]
 
@@ -18,7 +18,7 @@ Convert a CSV file to a custom output fo
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -58,3 +58,6 @@ Convert to carriage return line-endings:
 
     csvformat -M $'\r' examples/dummy.csv
 
+To avoid escaping quote characters when using :code:`--quoting 3`, add :code:`--out-quotechar ""`::
+
+    csvformat -u 3 -U 3 -Q "" examples/optional_quote_characters.csv
diff -pruN 1.0.2-2/docs/scripts/csvgrep.rst 1.0.5-1/docs/scripts/csvgrep.rst
--- 1.0.2-2/docs/scripts/csvgrep.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvgrep.rst	2020-03-03 02:59:56.000000000 +0000
@@ -9,23 +9,23 @@ Filter tabular data to only those rows w
 
     usage: csvgrep [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
                    [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                   [-v] [-l] [--zero] [-V] [-n] [-c COLUMNS] [-m PATTERN]
-                   [-r REGEX] [-f MATCHFILE] [-i]
+                   [-K SKIP_LINES] [-v] [-l] [--zero] [-V] [-n] [-c COLUMNS]
+                   [-m PATTERN] [-r REGEX] [-f MATCHFILE] [-i]
                    [FILE]
 
     Search CSV files. Like the Unix "grep" command, but for tabular data.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
       -n, --names           Display column names and indices from the input CSV
                             and exit.
       -c COLUMNS, --columns COLUMNS
-                            A comma separated list of column indices or names to
-                            be searched.
+                            A comma separated list of column indices, names or
+                            ranges to be searched, e.g. "1,id,3-5".
       -m PATTERN, --match PATTERN
                             The string to search for.
       -r REGEX, --regex REGEX
@@ -38,6 +38,8 @@ Filter tabular data to only those rows w
                             row will pass.
       -i, --invert-match    If specified, select non-matching instead of matching
                             rows.
+      -a  --any-match       If specified, select rows where any column matches
+                            instead of all columns.
 
 See also: :doc:`../common_arguments`.
 
@@ -53,8 +55,11 @@ Search for the row relating to Illinois:
 Search for rows relating to states with names beginning with the letter "I"::
 
     csvgrep -c 1 -r "^I" examples/realdata/FY09_EDU_Recipients_by_State.csv
-    
+
 Search for rows that do not contain an empty state cell::
 
     csvgrep -c 1 -r "^$" -i examples/realdata/FY09_EDU_Recipients_by_State.csv
 
+Perform a case-insensitive search::
+
+    csvgrep -c 1 -r "(?i)illinois" examples/realdata/FY09_EDU_Recipients_by_State.csv
diff -pruN 1.0.2-2/docs/scripts/csvjoin.rst 1.0.5-1/docs/scripts/csvjoin.rst
--- 1.0.2-2/docs/scripts/csvjoin.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvjoin.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,9 +8,11 @@ Description
 Merges two or more CSV tables together using a method analogous to SQL JOIN operation. By default it performs an inner join, but full outer, left outer, and right outer are also available via flags. Key columns are specified with the -c flag (either a single column which exists in all tables, or a comma-separated list of columns with one corresponding to each). If the columns flag is not provided then the tables will be merged "sequentially", that is they will be merged in row order with no filtering::
 
     usage: csvjoin [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                   [-v] [-l] [--zero] [-V] [-c COLUMNS] [--outer] [--left]
-                   [--right] [-y SNIFF_LIMIT] [-I]
+                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                   [-S] [--blanks] [--date-format DATE_FORMAT]
+                   [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                   [-l] [--zero] [-V] [-c COLUMNS] [--outer] [--left] [--right]
+                   [-y SNIFF_LIMIT] [-I]
                    [FILE [FILE ...]]
 
     Execute a SQL-like join to merge CSV files on a specified column or columns.
@@ -56,8 +58,10 @@ Examples
 
     csvjoin -c 1 examples/join_a.csv examples/join_b.csv
 
-This command says you have two files to outer join, file1.csv and file2.csv. The key column in file1.csv is ColumnKey, the key column in file2.csv is Column Key.
-
 Add two empty columns to the right of a CSV::
 
     echo "," | csvjoin examples/dummy.csv -
+
+Add a single column to the right of a CSV::
+
+    echo "new-column" | csvjoin examples/dummy.csv -
diff -pruN 1.0.2-2/docs/scripts/csvjson.rst 1.0.5-1/docs/scripts/csvjson.rst
--- 1.0.2-2/docs/scripts/csvjson.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvjson.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,7 +8,9 @@ Description
 Converts a CSV file into JSON or GeoJSON (depending on flags)::
 
     usage: csvjson [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-v]
+                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                   [-S] [--blanks] [--date-format DATE_FORMAT]
+                   [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
                    [-l] [--zero] [-V] [-i INDENT] [-k KEY] [--lat LAT] [--lon LON]
                    [--crs CRS] [--stream] [-y SNIFF_LIMIT] [-I]
                    [FILE]
@@ -17,7 +19,7 @@ Converts a CSV file into JSON or GeoJSON
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -35,15 +37,23 @@ Converts a CSV file into JSON or GeoJSON
       --lon LON             A column index or name containing a longitude. Output
                             will be GeoJSON instead of JSON. Only valid if --lat
                             is also specified.
+      --type TYPE           A column index or name containing a GeoJSON type.
+                            Output will be GeoJSON instead of JSON. Only valid if
+                            --lat and --lon are also specified.
+      --geometry GEOMETRY   A column index or name containing a GeoJSON geometry.
+                            Output will be GeoJSON instead of JSON. Only valid if
+                            --lat and --lon are also specified.
       --crs CRS             A coordinate reference system string to be included
                             with GeoJSON output. Only valid if --lat and --lon are
                             also specified.
+      --no-bbox             Disable the calculation of a bounding box.
       --stream              Output JSON as a stream of newline-separated objects,
                             rather than an as an array.
       -y SNIFF_LIMIT, --snifflimit SNIFF_LIMIT
                             Limit CSV dialect sniffing to the specified number of
                             bytes. Specify "0" to disable sniffing entirely.
-      -I, --no-inference    Disable type inference when parsing CSV input.
+      -I, --no-inference    Disable type inference (and --locale, --date-format,
+                            --datetime-format) when parsing CSV input.
 
 See also: :doc:`../common_arguments`.
 
diff -pruN 1.0.2-2/docs/scripts/csvlook.rst 1.0.5-1/docs/scripts/csvlook.rst
--- 1.0.2-2/docs/scripts/csvlook.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvlook.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,8 +8,10 @@ Description
 Renders a CSV to the command line in a Markdown-compatible, fixed-width format::
 
     usage: csvlook [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                   [-v] [-l] [--zero] [-V] [--max-rows MAX_ROWS]
+                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                   [-S] [--blanks] [--date-format DATE_FORMAT]
+                   [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                   [-l] [--zero] [-V] [--max-rows MAX_ROWS]
                    [--max-columns MAX_COLUMNS]
                    [--max-column-width MAX_COLUMN_WIDTH] [-y SNIFF_LIMIT] [-I]
                    [FILE]
@@ -18,7 +20,7 @@ Renders a CSV to the command line in a M
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
diff -pruN 1.0.2-2/docs/scripts/csvpy.rst 1.0.5-1/docs/scripts/csvpy.rst
--- 1.0.2-2/docs/scripts/csvpy.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvpy.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,15 +8,17 @@ Description
 Loads a CSV file into a :class:`agate.csv.Reader` object and then drops into a Python shell so the user can inspect the data however they see fit::
 
     usage: csvpy [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                 [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-v]
-                 [-V] [--dict] [--agate]
+                 [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                 [-S] [--blanks] [--date-format DATE_FORMAT]
+                 [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                 [-l] [--zero] [-V] [--dict] [--agate]
                  [FILE]
 
     Load a CSV file into a CSV reader and then drop into a Python shell.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -27,7 +29,7 @@ This tool will automatically use the IPy
 
 .. note::
 
-    Due to platform limitations, csvpy does not accept file input on STDIN. 
+    Due to platform limitations, csvpy does not accept file input as piped data via STDIN. 
 
 See also: :doc:`../common_arguments`.
 
diff -pruN 1.0.2-2/docs/scripts/csvsort.rst 1.0.5-1/docs/scripts/csvsort.rst
--- 1.0.2-2/docs/scripts/csvsort.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvsort.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,24 +8,26 @@ Description
 Sort CSV files. Like the Unix "sort" command, but for tabular data::
 
     usage: csvsort [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                   [-v] [-l] [--zero] [-V] [-n] [-c COLUMNS] [-r] [-y SNIFF_LIMIT]
-                   [-I]
+                   [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                   [-S] [--blanks] [--date-format DATE_FORMAT]
+                   [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                   [-l] [--zero] [-V] [-n] [-c COLUMNS] [-r] [-y SNIFF_LIMIT] [-I]
                    [FILE]
 
     Sort CSV files. Like the Unix "sort" command, but for tabular data.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
       -n, --names           Display column names and indices from the input CSV
                             and exit.
       -c COLUMNS, --columns COLUMNS
-                            A comma separated list of column indices or names to
-                            sort by. Defaults to all columns.
+                            A comma separated list of column indices, names or
+                            ranges to sort by, e.g. "1,id,3-5". Defaults to all
+                            columns.
       -r, --reverse         Sort in descending order.
       -y SNIFF_LIMIT, --snifflimit SNIFF_LIMIT
                             Limit CSV dialect sniffing to the specified number of
diff -pruN 1.0.2-2/docs/scripts/csvsql.rst 1.0.5-1/docs/scripts/csvsql.rst
--- 1.0.2-2/docs/scripts/csvsql.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvsql.rst	2020-03-03 02:59:56.000000000 +0000
@@ -8,12 +8,16 @@ Description
 Generate SQL statements for a CSV file or execute those statements directly on a database. In the latter case supports both creating tables and inserting data::
 
     usage: csvsql [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                  [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                  [-v] [--zero] [-V]
-                  [-i {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase}]
+                  [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                  [-S] [--blanks] [--date-format DATE_FORMAT]
+                  [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                  [-l] [--zero] [-V]
+                  [-i {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase,crate}]
                   [--db CONNECTION_STRING] [--query QUERY] [--insert]
-                  [--tables TABLE_NAMES] [--no-constraints] [--no-create]
-                  [--blanks] [--db-schema DB_SCHEMA] [-y SNIFF_LIMIT] [-I]
+                  [--prefix PREFIX] [--tables TABLE_NAMES] [--no-constraints]
+                  [--unique-constraint UNIQUE_CONSTRAINT] [--no-create]
+                  [--create-if-not-exists] [--overwrite] [--db-schema DB_SCHEMA]
+                  [-y SNIFF_LIMIT] [-I] [--chunk-size NUM]
                   [FILE [FILE ...]]
 
     Generate SQL statements for one or more CSV files, or execute those statements
@@ -21,32 +25,40 @@ Generate SQL statements for a CSV file o
 
     positional arguments:
       FILE                  The CSV file(s) to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
-      -i {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase}, --dialect {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase}
+      -i {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase,crate}, --dialect {firebird,mssql,mysql,oracle,postgresql,sqlite,sybase,crate}
                             Dialect of SQL to generate. Only valid when --db is
                             not specified.
       --db CONNECTION_STRING
                             If present, a sqlalchemy connection string to use to
                             directly execute generated SQL on a database.
       --query QUERY         Execute one or more SQL queries delimited by ";" and
-                            output the result of the last query as CSV. QUERY
-                            may be a filename.
+                            output the result of the last query as CSV. QUERY may
+                            be a filename.
       --insert              In addition to creating the table, also insert the
                             data into the table. Only valid when --db is
                             specified.
       --prefix PREFIX       Add an expression following the INSERT keyword, like
-                            IGNORE or REPLACE.
-      --tables TABLE_NAMES  Specify the names of the tables to be created. By
-                            default, the tables will be named after the filenames
-                            without extensions or "stdin".
+                            OR IGNORE or OR REPLACE.
+      --tables TABLE_NAMES  A comma-separated list of names of tables to be
+                            created. By default, the tables will be named after
+                            the filenames without extensions or "stdin".
       --no-constraints      Generate a schema without length limits or null
                             checks. Useful when sampling big tables.
+      --unique-constraint UNIQUE_CONSTRAINT
+                            A column-separated list of names of columns to include
+                            in a UNIQUE constraint.
       --no-create           Skip creating a table. Only valid when --insert is
                             specified.
-      --overwrite           Drop the table before creating.
+      --create-if-not-exists
+                            Create table if it does not exist, otherwise keep
+                            going. Only valid when --insert is specified.
+      --overwrite           Drop the table before creating. Only valid when
+                            --insert is specified and --no-create is not
+                            specified.
       --db-schema DB_SCHEMA
                             Optional name of database schema to create table(s)
                             in.
@@ -54,6 +66,9 @@ Generate SQL statements for a CSV file o
                             Limit CSV dialect sniffing to the specified number of
                             bytes. Specify "0" to disable sniffing entirely.
       -I, --no-inference    Disable type inference when parsing the input.
+      --chunk-size NUM
+                            Chunk size for batch insert into the table.
+                            Only valid when --insert is specified.
 
 See also: :doc:`../common_arguments`.
 
@@ -61,10 +76,13 @@ For information on connection strings an
 
 If you prefer not to enter your password in the connection string, store the password securely in a `PostgreSQL Password File <https://www.postgresql.org/docs/9.1/static/libpq-pgpass.html>`_, a `MySQL Options File <https://dev.mysql.com/doc/refman/5.7/en/option-files.html>`_ or similar files for other systems.
 
+.. note::
+
+    Using the :code:`--query` option may cause rounding (in Python 2) or introduce [Python floating point issues](https://docs.python.org/3.4/tutorial/floatingpoint.html) (in Python 3).
 
 .. note::
 
-    Using the ``--query`` option may cause rounding (in Python 2) or introduce [Python floating point issues](https://docs.python.org/3.4/tutorial/floatingpoint.html) (in Python 3).
+    Alternatives to :doc:`csvsql` are `q <https://github.com/harelba/q>`_ and `textql <https://github.com/dinedal/textql>`_.
 
 Examples
 ========
@@ -78,7 +96,7 @@ Create a table and import data from the
     createdb test
     csvsql --db postgresql:///test --tables fy09 --insert examples/realdata/FY09_EDU_Recipients_by_State.csv
 
-For large tables it may not be practical to process the entire table. One solution to this is to analyze a sample of the table. In this case it can be useful to turn off length limits and null checks with the ``no-constraints`` option::
+For large tables it may not be practical to process the entire table. One solution to this is to analyze a sample of the table. In this case it can be useful to turn off length limits and null checks with the :code:`--no-constraints` option::
 
     head -n 20 examples/realdata/FY09_EDU_Recipients_by_State.csv | csvsql --no-constraints --tables fy09
 
@@ -99,3 +117,11 @@ Group rows by one column::
 You can also use CSVSQL to "directly" query one or more CSV files. Please note that this will create an in-memory SQL database, so it won't be very fast::
 
     csvsql --query  "select m.usda_id, avg(i.sepal_length) as mean_sepal_length from iris as i join irismeta as m on (i.species = m.species) group by m.species" examples/iris.csv examples/irismeta.csv
+
+Concatenate two columns::
+
+    csvsql --query "select a || b from 'dummy3'" examples/dummy3.csv
+
+If a column contains null values, you must ``COALESCE`` the column::
+
+    csvsql --query "select a || COALESCE(b, '') from 'sort_ints_nulls'" --no-inference examples/sort_ints_nulls.csv
diff -pruN 1.0.2-2/docs/scripts/csvstack.rst 1.0.5-1/docs/scripts/csvstack.rst
--- 1.0.2-2/docs/scripts/csvstack.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvstack.rst	2020-03-03 02:59:56.000000000 +0000
@@ -9,15 +9,16 @@ Stack up the rows from multiple CSV file
 
     usage: csvstack [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
                     [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                    [-v] [-l] [--zero] [-V] [-g GROUPS] [-n GROUP_NAME]
-                    [--filenames]
+                    [-K SKIP_LINES] [-v] [-l] [--zero] [-V] [-g GROUPS]
+                    [-n GROUP_NAME] [--filenames]
                     FILE [FILE ...]
 
     Stack up the rows from multiple CSV files, optionally adding a grouping value.
+    Files are assumed to have the same columns in the same order.
 
     positional arguments:
       FILE                  The CSV file(s) to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -37,7 +38,7 @@ See also: :doc:`../common_arguments`.
 
 .. warn::
 
-    If you redirect output to an input file like ``csvstack file.csv > file.csv``, the file will grow indefinitely.
+    If you redirect output to an input file like :code:`csvstack file.csv > file.csv`, the file will grow indefinitely.
 
 Examples
 ========
@@ -45,3 +46,7 @@ Examples
 Contrived example: joining a set of homogoenous files for different years::
 
     csvstack -g 2009,2010 examples/realdata/FY09_EDU_Recipients_by_State.csv examples/realdata/Datagov_FY10_EDU_recp_by_State.csv
+
+Add a single column to the left of a CSV::
+
+    csvstack -n NEWCOL -g "" examples/dummy.csv
diff -pruN 1.0.2-2/docs/scripts/csvstat.rst 1.0.5-1/docs/scripts/csvstat.rst
--- 1.0.2-2/docs/scripts/csvstat.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/csvstat.rst	2020-03-03 02:59:56.000000000 +0000
@@ -9,17 +9,17 @@ Prints descriptive statistics for all co
 
     usage: csvstat [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
                    [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                   [-v] [--zero] [-V] [--csv] [-n] [-c COLUMNS] [--type] [--nulls]
-                   [--unique] [--min] [--max] [--sum] [--mean] [--median]
-                   [--stdev] [--len] [--freq] [--freq-count FREQ_COUNT] [--count]
-                   [-y SNIFF_LIMIT]
+                   [-K SKIP_LINES] [-v] [-l] [--zero] [-V] [--csv] [-n]
+                   [-c COLUMNS] [--type] [--nulls] [--unique] [--min] [--max]
+                   [--sum] [--mean] [--median] [--stdev] [--len] [--freq]
+                   [--freq-count FREQ_COUNT] [--count] [-y SNIFF_LIMIT]
                    [FILE]
 
     Print descriptive statistics for each column in a CSV file.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -27,8 +27,9 @@ Prints descriptive statistics for all co
       -n, --names           Display column names and indices from the input CSV
                             and exit.
       -c COLUMNS, --columns COLUMNS
-                            A comma separated list of column indices or names to
-                            be examined. Defaults to all columns.
+                            A comma separated list of column indices, names or
+                            ranges to be examined, e.g. "1,id,3-5". Defaults to
+                            all columns.
       --type                Only output data type.
       --nulls               Only output whether columns contains nulls.
       --unique              Only output counts of unique values.
diff -pruN 1.0.2-2/docs/scripts/in2csv.rst 1.0.5-1/docs/scripts/in2csv.rst
--- 1.0.2-2/docs/scripts/in2csv.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/in2csv.rst	2020-03-03 02:59:56.000000000 +0000
@@ -17,16 +17,19 @@ Converting fixed width requires that you
 The header line is required though the columns may be in any order::
 
     usage: in2csv [-h] [-d DELIMITER] [-t] [-q QUOTECHAR] [-u {0,1,2,3}] [-b]
-                  [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-S] [-H]
-                  [-v] [-l] [--zero] [-V] [-f FILETYPE] [-s SCHEMA] [-k KEY] [-n]
-                  [--sheet SHEET] [-y SNIFF_LIMIT] [-I]
+                  [-p ESCAPECHAR] [-z FIELD_SIZE_LIMIT] [-e ENCODING] [-L LOCALE]
+                  [-S] [--blanks] [--date-format DATE_FORMAT]
+                  [--datetime-format DATETIME_FORMAT] [-H] [-K SKIP_LINES] [-v]
+                  [-l] [--zero] [-V] [-f FILETYPE] [-s SCHEMA] [-k KEY] [-n]
+                  [--sheet SHEET] [--write-sheets WRITE_SHEETS]
+                  [--encoding-xls ENCODING_XLS] [-y SNIFF_LIMIT] [-I]
                   [FILE]
 
     Convert common, but less awesome, tabular data formats to CSV.
 
     positional arguments:
       FILE                  The CSV file to operate on. If omitted, will accept
-                            input on STDIN.
+                            input as piped data via STDIN.
 
     optional arguments:
       -h, --help            show this help message and exit
@@ -47,7 +50,8 @@ The header line is required though the c
       -y SNIFF_LIMIT, --snifflimit SNIFF_LIMIT
                             Limit CSV dialect sniffing to the specified number of
                             bytes. Specify "0" to disable sniffing entirely.
-      -I, --no-inference    Disable type inference when parsing CSV input.
+      -I, --no-inference    Disable type inference (and --locale, --date-format,
+                            --datetime-format) when parsing CSV input.
 
     Some command-line flags only pertain to specific input formats.
 
@@ -93,3 +97,7 @@ Fetch csvkit's open issues from the GitH
 Convert a DBase DBF file to an equivalent CSV::
 
     in2csv examples/testdbf.dbf
+
+This tool names unnamed headers. To avoid that behavior, run::
+
+    in2csv --no-header-row examples/test.xlsx | tail -n +2
diff -pruN 1.0.2-2/docs/scripts/sql2csv.rst 1.0.5-1/docs/scripts/sql2csv.rst
--- 1.0.2-2/docs/scripts/sql2csv.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/scripts/sql2csv.rst	2020-03-03 02:59:56.000000000 +0000
@@ -19,11 +19,6 @@ Executes arbitrary commands against a SQ
 
     optional arguments:
       -h, --help            show this help message and exit
-      -v, --verbose         Print detailed tracebacks when errors occur.
-      -l, --linenumbers     Insert a column of line numbers at the front of the
-                            output. Useful when piping to grep or as a simple
-                            primary key.
-      -V, --version         Display version information and exit.
       --db CONNECTION_STRING
                             An sqlalchemy connection string to connect to a
                             database.
diff -pruN 1.0.2-2/docs/tricks.rst 1.0.5-1/docs/tricks.rst
--- 1.0.2-2/docs/tricks.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/tricks.rst	2020-03-03 02:59:56.000000000 +0000
@@ -15,23 +15,16 @@ csvkit has builtin support for reading `
 
 Please note, the files are decompressed in memory, so this is a convenience, not an optimization.
 
-Reading a CSV with a byte-order mark (BOM)
-------------------------------------------
-
-Set the encoding to ``utf-8-sig``, for example::
-
-    csvcut -e utf-8-sig -c column1 csv-with-bom.csv
-
 Specifying STDIN as a file
 --------------------------
 
-Most tools use ``STDIN`` as input if no filename is given, but tools that accept multiple inputs like :doc:`scripts/csvjoin` and :doc:`scripts/csvstack` don't. To use ``STDIN`` as an input to these tools, use ``-`` as the filename. For example, these three commands produce the same output::
+Most tools use ``STDIN`` as input if no filename is given, but tools that accept multiple inputs like :doc:`/scripts/csvjoin` and :doc:`/scripts/csvstack` don't. To use ``STDIN`` as an input to these tools, use ``-`` as the filename. For example, these three commands produce the same output::
 
     csvstat examples/dummy.csv
     cat examples/dummy.csv | csvstat
     cat examples/dummy.csv | csvstat -
 
-``csvstack`` can take a filename and ``STDIN`` as input, for example::
+:doc:`/scripts/csvstack` can take a filename and ``STDIN`` as input, for example::
 
     cat examples/dummy.csv | csvstack examples/dummy3.csv -
 
@@ -49,9 +42,14 @@ csvkit is supported on:
 
 * Python 2.7+
 * Python 3.3+
-* `PyPy <http://pypy.org/>`_
 
-It is tested on OS X, and has also been used on Linux and Windows.
+It is tested on macOS, and has also been used on Linux and Windows.
+
+If installing on macOS, you may need to install Homebrew first::
+
+    /usr/bin/ruby -e "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)"
+    brew install python
+    pip install csvkit
 
 If installing on Ubuntu, you may need to install Python's development headers first::
 
@@ -63,7 +61,7 @@ If the installation is successful but cs
     pip install --upgrade setuptools
     pip install --upgrade csvkit
 
-On OS X, if you see `OSError: [Errno 1] Operation not permitted`, try::
+On macOS, if you see ``OSError: [Errno 1] Operation not permitted``, try::
 
     sudo pip install --ignore-installed csvkit
 
@@ -81,7 +79,8 @@ CSV formatting and parsing
 * Are values appearing in incorrect columns?
 * Does the output combine multiple fields into a single column with double-quotes?
 * Does the outplit split a single field into multiple columns?
-* Are `csvstat -c 1` and `csvstat --count` reporting inconsistent row counts?
+* Are :code:`csvstat -c 1` and :code:`csvstat --count` reporting inconsistent row counts?
+* Do you see ``Row # has # values, but Table only has # columns.``?
 
 These may be symptoms of CSV sniffing gone wrong. As there is no single, standard CSV format, csvkit uses Python's `csv.Sniffer <https://docs.python.org/3.5/library/csv.html#csv.Sniffer>`_ to deduce the format of a CSV file: that is, the field delimiter and quote character. By default, the entire file is sent for sniffing, which can be slow. You can send a small sample with the :code:`--snifflimit` option. If you're encountering any cases above, you can try setting :code:`--snifflimit 0` to disable sniffing and set the :code:`--delimiter` and :code:`--quotechar` options yourself.
 
@@ -96,26 +95,26 @@ CSV data interpretation
 
 These may be symptoms of csvkit's type inference being too aggressive for your data. CSV is a text format, but it may contain text representing numbers, dates, booleans or other types. csvkit attempts to reverse engineer that text into proper data types—a process called "type inference".
 
-For some data, type inference can be error prone. If necessary you can disable it with the To :code:`--no-inference` switch. This will force all columns to be treated as regular text.
+For some data, type inference can be error prone. If necessary you can disable it with the :code:`--no-inference` switch. This will force all columns to be treated as regular text.
 
 Slow performance
 ----------------
 
-csvkit's tools fall into two categories: Those that load an entire CSV into memory (e.g. :doc:`/scripts/csvstat`) and those that only read data one row at a time (e.g. :doc:`/scripts/csvcut`). Those that stream results will generally be very fast. For those that buffer the entire file, the slowest part of that process is typically the "type inference" described in the previous section.
+csvkit's tools fall into two categories: Those that load an entire CSV into memory (e.g. :doc:`/scripts/csvstat`) and those that only read data one row at a time (e.g. :doc:`/scripts/csvcut`). Those that stream results will generally be very fast. See :doc:`contributing` for a full list. For those that buffer the entire file, the slowest part of that process is typically the "type inference" described in the previous section.
 
 If a tool is too slow to be practical for your data try setting the :code:`--snifflimit` option or using the :code:`--no-inference`.
 
 Database errors
 ---------------
 
-Are you seeing this error message, even after running :code:`pip install psycopg2` or :code:`pip install MySQL-python`?
+Are you seeing this error message, even after running :code:`pip install psycopg2` or :code:`pip install mysql-connector-python`?
 
 ::
 
     You don't appear to have the necessary database backend installed for connection string you're trying to use. Available backends include:
 
     Postgresql: pip install psycopg2
-    MySQL:      pip install MySQL-python
+    MySQL:      pip install mysql-connector-python
 
     For details on connection strings and other backends, please see the SQLAlchemy documentation on dialects at:
 
diff -pruN 1.0.2-2/docs/tutorial/1_getting_started.rst 1.0.5-1/docs/tutorial/1_getting_started.rst
--- 1.0.2-2/docs/tutorial/1_getting_started.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/tutorial/1_getting_started.rst	2020-03-03 02:59:56.000000000 +0000
@@ -112,7 +112,7 @@ csvcut: data scalpel
      13: federal_supply_class
      14: federal_supply_class_name
 
-As you'll can see, our dataset has fourteen columns. Let's take a look at just columns ``2``, ``5`` and ``6``:
+As you can see, our dataset has fourteen columns. Let's take a look at just columns ``2``, ``5`` and ``6``:
 
 .. code-block:: bash
 
@@ -137,11 +137,11 @@ Now that we understand :doc:`/scripts/in
 
 In addition to specifying filenames, all csvkit tools accept an input file via "standard in". This means that, using the ``|`` ("pipe") character we can use the output of one csvkit tool as the input of the next.
 
-In the example above, the output of ``csvcut`` becomes the input to ``csvlook``. This also allow us to pipe output to standard Unix commands such as ``head``, which prints only the first ten lines of its input. Here, the output of ``csvlook`` becomes the input of ``head``.
+In the example above, the output of :doc:`/scripts/csvcut` becomes the input to :doc:`/scripts/csvlook`. This also allow us to pipe output to standard Unix commands such as ``head``, which prints only the first ten lines of its input. Here, the output of :doc:`/scripts/csvlook` becomes the input of ``head``.
 
 Piping is a core feature of csvkit. Of course, you can always write the output of each command to a file using ``>``. However, it's often faster and more convenient to use pipes to chain several commands together.
 
-We can also pipe ``in2csv``, allowing us to combine all our previous operations into one:
+We can also pipe :doc:`/scripts/in2csv`, allowing us to combine all our previous operations into one:
 
 .. code-block:: bash
 
diff -pruN 1.0.2-2/docs/tutorial/2_examining_the_data.rst 1.0.5-1/docs/tutorial/2_examining_the_data.rst
--- 1.0.2-2/docs/tutorial/2_examining_the_data.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/tutorial/2_examining_the_data.rst	2020-03-03 02:59:56.000000000 +0000
@@ -7,9 +7,9 @@ csvstat: statistics without code
 
 In the previous section we saw how we could use :doc:`csvlook` and :doc:`csvcut` to view slices of our data. This is a good tool for exploring a dataset, but in practice we usually need to get the broadest possible view before we can start diving into specifics.
 
-:doc:`/scripts/csvstat` is designed to give us just such a broad understanding of our data. Inspired by the ``summary()`` function from the computational statistics programming language `"R" <http://www.r-project.org/>`_, ``csvstat`` will generate summary statistics for all the data in a CSV file.
+:doc:`/scripts/csvstat` is designed to give us just such a broad understanding of our data. Inspired by the ``summary()`` function from the computational statistics programming language `"R" <http://www.r-project.org/>`_, :doc:`/scripts/csvstat` will generate summary statistics for all the data in a CSV file.
 
-Let's examine summary statistics for a few columns from our dataset. As we learned in the last section, we can use ``csvcut`` and a pipe to pick out the columns we want:
+Let's examine summary statistics for a few columns from our dataset. As we learned in the last section, we can use :doc:`/scripts/csvcut` and a pipe to pick out the columns we want:
 
 .. code-block:: bash
 
@@ -72,7 +72,7 @@ As a journalist, this quick glance at th
 csvgrep: find the data you need
 ===============================
 
-After reviewing the summary statistics you might wonder what equipment was received by a particular county. To get a simple answer to the question we can use :doc:`/scripts/csvgrep` to search for the state's name amongst the rows. Let's also use ``csvcut`` to just look at the columns we care about and ``csvlook`` to format the output:
+After reviewing the summary statistics you might wonder what equipment was received by a particular county. To get a simple answer to the question we can use :doc:`/scripts/csvgrep` to search for the state's name amongst the rows. Let's also use :doc:`/scripts/csvcut` to just look at the columns we care about and :doc:`/scripts/csvlook` to format the output:
 
 .. code-block:: bash
 
diff -pruN 1.0.2-2/docs/tutorial/3_power_tools.rst 1.0.5-1/docs/tutorial/3_power_tools.rst
--- 1.0.2-2/docs/tutorial/3_power_tools.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/tutorial/3_power_tools.rst	2020-03-03 02:59:56.000000000 +0000
@@ -5,7 +5,7 @@ Power tools
 csvjoin: merging related data
 =============================
 
-One of the most common operations that we need to perform on data is "joining" it to other, related data. For instance, given a dataset about equipment supplied to counties in Nebraska, one might reasonably want to merge that with a dataset containing the population of each county. :doc:`/scripts/csvjoin` allows us to take two those two datasets (equipment and population) and merge them, much like you might do with a SQL ``JOIN`` query. In order to demonstrate this, let's grab a second dataset:
+One of the most common operations that we need to perform on data is "joining" it to other, related data. For instance, given a dataset about equipment supplied to counties in Nebraska, one might reasonably want to merge that with a dataset containing the population of each county. :doc:`/scripts/csvjoin` allows us to take those two datasets (equipment and population) and merge them, much like you might do with a SQL ``JOIN`` query. In order to demonstrate this, let's grab a second dataset:
 
 .. code-block:: bash
 
@@ -106,7 +106,7 @@ Since both files contain a fips column,
     | NANCE      | RIFLE,7.62 MILLIMETER                                          |            3,730 |
     | NANCE      | RIFLE,7.62 MILLIMETER                                          |            3,730 |
 
-Two counties with fewer than one-thousand residents were the recipients of 5.56 millimeter assault rifles. This simple example demonstrates the power of joining datasets. Although SQL will always be a more flexible option, ``csvjoin`` will often get you where you need to go faster.
+Two counties with fewer than one-thousand residents were the recipients of 5.56 millimeter assault rifles. This simple example demonstrates the power of joining datasets. Although SQL will always be a more flexible option, :doc:`/scripts/csvjoin` will often get you where you need to go faster.
 
 csvstack: combining subsets
 ===========================
@@ -164,14 +164,14 @@ Using csvstat we can see that our ``regi
 
     Row count: 2611
 
-If you supply the ``-g`` flag then ``csvstack`` can also add a "grouping column" to each row, so that you can tell which file each row came from. In this case we don't need this, but you can imagine a situation in which instead of having a ``county`` column each of this datasets had simply been named ``nebraska.csv`` and ``kansas.csv``. In that case, using a grouping column would prevent us from losing information when we stacked them.
+If you supply the :code:`-g` flag then :doc:`/scripts/csvstack` can also add a "grouping column" to each row, so that you can tell which file each row came from. In this case we don't need this, but you can imagine a situation in which instead of having a ``county`` column each of this datasets had simply been named ``nebraska.csv`` and ``kansas.csv``. In that case, using a grouping column would prevent us from losing information when we stacked them.
 
 csvsql and sql2csv: ultimate power
 ==================================
 
-Sometimes (almost always), the command-line isn't enough. It would be crazy to try to do all your analysis using command-line tools. Often times, the correct tool for data analysis is SQL. :doc:`/scripts/csvsql` and :doc:`/scripts/sql2csv` form a bridge that eases migrating your data into and out of a SQL database. For smaller datasets ``csvsql`` can also leverage `sqlite <https://www.sqlite.org/>`_ to allow execution of ad hoc SQL queries without ever touching a database.
+Sometimes (almost always), the command-line isn't enough. It would be crazy to try to do all your analysis using command-line tools. Often times, the correct tool for data analysis is SQL. :doc:`/scripts/csvsql` and :doc:`/scripts/sql2csv` form a bridge that eases migrating your data into and out of a SQL database. For smaller datasets :doc:`/scripts/csvsql` can also leverage `sqlite <https://www.sqlite.org/>`_ to allow execution of ad hoc SQL queries without ever touching a database.
 
-By default, ``csvsql`` will generate a create table statement for your data. You can specify what sort of database you are using with the ``-i`` flag:
+By default, :doc:`/scripts/csvsql` will generate a create table statement for your data. You can specify what sort of database you are using with the ``-i`` flag:
 
 .. code-block:: bash
 
@@ -199,27 +199,27 @@ By default, ``csvsql`` will generate a c
             margin_of_error DECIMAL NOT NULL
     );
 
-Here we have the sqlite "create table" statement for our joined data. You'll see that, like ``csvstat``, ``csvsql`` has done its best to infer the column types.
+Here we have the sqlite "create table" statement for our joined data. You'll see that, like :doc:`/scripts/csvstat`, :doc:`/scripts/csvsql` has done its best to infer the column types.
 
-Often you won't care about storing the SQL statements locally. You can also use ``csvsql`` to create the table directly in the database on your local machine. If you add the ``--insert`` option the data will also be imported:
+Often you won't care about storing the SQL statements locally. You can also use :doc:`/scripts/csvsql` to create the table directly in the database on your local machine. If you add the :code:`--insert` option the data will also be imported:
 
 .. code-block:: bash
 
     csvsql --db sqlite:///leso.db --insert joined.csv
 
-How can we check that our data was imported successfully? We could use the sqlite command-line interface, but rather than worry about the specifics of another tool, we can also use ``sql2csv``:
+How can we check that our data was imported successfully? We could use the sqlite command-line interface, but rather than worry about the specifics of another tool, we can also use :doc:`/scripts/sql2csv`:
 
 .. code-block:: bash
 
     sql2csv --db sqlite:///leso.db --query "select * from joined"
 
-Note that the ``--query`` parameter to ``sql2csv`` accepts any SQL query. For example, to export Douglas county from the ``joined`` table from our sqlite database, we would run:
+Note that the :code:`--query` parameter to :doc:`/scripts/sql2csv` accepts any SQL query. For example, to export Douglas county from the ``joined`` table from our sqlite database, we would run:
 
 .. code-block:: bash
 
     sql2csv --db sqlite:///leso.db --query "select * from joined where county='DOUGLAS';" > douglas.csv
 
-Sometimes, if you will only be running a single query, even constructing the database is a waste of time. For that case, you can actually skip the database entirely and ``csvsql`` will create one in memory for you:
+Sometimes, if you will only be running a single query, even constructing the database is a waste of time. For that case, you can actually skip the database entirely and :doc:`/scripts/csvsql` will create one in memory for you:
 
 .. code-block:: bash
 
@@ -230,4 +230,4 @@ SQL queries directly on CSVs! Keep in mi
 Summing up
 ==========
 
-``csvjoin``, ``csvstack``, ``csvsql`` and ``sql2csv`` represent the power tools of csvkit. Using these tools can vastly simplify processes that would otherwise require moving data between other systems. But what about cases where these tools still don't cut it? What if you need to move your data onto the web or into a legacy database system? We've got a few solutions for those problems in our final section, :doc:`4_going_elsewhere`.
+:doc:`/scripts/csvjoin`, :doc:`/scripts/csvstack`, :doc:`/scripts/csvsql` and :doc:`/scripts/sql2csv` represent the power tools of csvkit. Using these tools can vastly simplify processes that would otherwise require moving data between other systems. But what about cases where these tools still don't cut it? What if you need to move your data onto the web or into a legacy database system? We've got a few solutions for those problems in our final section, :doc:`4_going_elsewhere`.
diff -pruN 1.0.2-2/docs/tutorial/4_going_elsewhere.rst 1.0.5-1/docs/tutorial/4_going_elsewhere.rst
--- 1.0.2-2/docs/tutorial/4_going_elsewhere.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/docs/tutorial/4_going_elsewhere.rst	2020-03-03 02:59:56.000000000 +0000
@@ -5,7 +5,7 @@ Going elsewhere with your data
 csvjson: going online
 =====================
 
-Very frequently one of the last steps in any data analysis is to get the data onto the web for display as a table, map or chart. CSV is rarely the ideal format for this. More often than not what you want is JSON and that's where :doc:`/scripts/csvjson` comes in. ``csvjson`` takes an input CSV and outputs neatly formatted JSON. For the sake of illustration, let's use ``csvcut`` and ``csvgrep`` to convert just a small slice of our data:
+Very frequently one of the last steps in any data analysis is to get the data onto the web for display as a table, map or chart. CSV is rarely the ideal format for this. More often than not what you want is JSON and that's where :doc:`/scripts/csvjson` comes in. :doc:`/scripts/csvjson` takes an input CSV and outputs neatly formatted JSON. For the sake of illustration, let's use :doc:`/scripts/csvcut` and :doc:`/scripts/csvgrep` to convert just a small slice of our data:
 
 .. code-block:: bash
 
@@ -50,7 +50,7 @@ A common usage of turning a CSV into a J
         }
     }
 
-For making maps, ``csvjson`` can also output GeoJSON, see its :doc:`/scripts/csvjson` for more details.
+For making maps, :doc:`/scripts/csvjson` can also output GeoJSON, see its :doc:`/scripts/csvjson` for more details.
 
 csvpy: going into code
 ======================
@@ -64,7 +64,7 @@ For the programmers out there, the comma
 .. code-block:: none
 
     Welcome! "data.csv" has been loaded in a reader object named "reader".
-    >>> print len(list(reader))
+    >>> print(len(list(reader)))
     1037
     >>> quit()
 
diff -pruN 1.0.2-2/examples/date_like_number.csv 1.0.5-1/examples/date_like_number.csv
--- 1.0.2-2/examples/date_like_number.csv	1970-01-01 00:00:00.000000000 +0000
+++ 1.0.5-1/examples/date_like_number.csv	2020-03-03 02:59:56.000000000 +0000
@@ -0,0 +1,2 @@
+a
+4.5
diff -pruN 1.0.2-2/examples/test_numeric_date_format.csv 1.0.5-1/examples/test_numeric_date_format.csv
--- 1.0.2-2/examples/test_numeric_date_format.csv	1970-01-01 00:00:00.000000000 +0000
+++ 1.0.5-1/examples/test_numeric_date_format.csv	2020-03-03 02:59:56.000000000 +0000
@@ -0,0 +1,3 @@
+a
+20140102
+20121231
diff -pruN 1.0.2-2/examples/test_utf8_bom.csv 1.0.5-1/examples/test_utf8_bom.csv
--- 1.0.2-2/examples/test_utf8_bom.csv	1970-01-01 00:00:00.000000000 +0000
+++ 1.0.5-1/examples/test_utf8_bom.csv	2020-03-03 02:59:56.000000000 +0000
@@ -0,0 +1,3 @@
+﻿foo,bar,baz
+1,2,3
+4,5,ʤ
\ No newline at end of file
diff -pruN 1.0.2-2/MANIFEST.in 1.0.5-1/MANIFEST.in
--- 1.0.2-2/MANIFEST.in	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/MANIFEST.in	2020-03-03 02:59:56.000000000 +0000
@@ -3,3 +3,5 @@ include README.rst
 recursive-include docs *
 recursive-include examples *
 recursive-include tests *.py
+include AUTHORS.rst
+include CHANGELOG.rst
diff -pruN 1.0.2-2/README.rst 1.0.5-1/README.rst
--- 1.0.2-2/README.rst	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/README.rst	2020-03-03 02:59:56.000000000 +0000
@@ -1,19 +1,11 @@
-.. image:: https://secure.travis-ci.org/wireservice/csvkit.png
+.. image:: https://secure.travis-ci.org/wireservice/csvkit.svg
     :target: https://travis-ci.org/wireservice/csvkit
     :alt: Build Status
 
-.. image:: https://gemnasium.com/wireservice/csvkit.png
-    :target: https://gemnasium.com/wireservice/csvkit
-    :alt: Dependency Status
-
-.. image:: https://coveralls.io/repos/wireservice/csvkit/badge.png?branch=master
+.. image:: https://coveralls.io/repos/wireservice/csvkit/badge.svg?branch=master
     :target: https://coveralls.io/r/wireservice/csvkit
     :alt: Coverage Status
 
-.. image:: https://img.shields.io/pypi/dw/csvkit.svg
-    :target: https://pypi.python.org/pypi/csvkit
-    :alt: PyPI downloads
-
 .. image:: https://img.shields.io/pypi/v/csvkit.svg
     :target: https://pypi.python.org/pypi/csvkit
     :alt: Version
@@ -26,16 +18,17 @@
     :target: https://pypi.python.org/pypi/csvkit
     :alt: Support Python versions
 
-csvkit is a suite of command-line tools for converting to and working with CSV, the king of tabular file formats.
+.. image:: https://img.shields.io/pypi/dm/csvkit.svg
+    :target: https://pypi.python.org/pypi/csvkit
+    :alt: Downloads per month on PyPI
 
-It is inspired by pdftk, gdal and the original csvcut tool by Joe Germuska and Aaron Bycoffe.
+csvkit is a suite of command-line tools for converting to and working with CSV, the king of tabular file formats.
 
-If you need to do more complex data analysis than csvkit can handle, use `agate <https://github.com/wireservice/agate>`_.
+It is inspired by pdftk, GDAL and the original csvcut tool by Joe Germuska and Aaron Bycoffe.
 
 Important links:
 
+* Documentation: http://csvkit.rtfd.org/
 * Repository:    https://github.com/wireservice/csvkit
 * Issues:        https://github.com/wireservice/csvkit/issues
-* Documentation: http://csvkit.rtfd.org/
 * Schemas:       https://github.com/wireservice/ffs
-* Buildbot:      https://travis-ci.org/wireservice/csvkit
diff -pruN 1.0.2-2/requirements-py2.txt 1.0.5-1/requirements-py2.txt
--- 1.0.2-2/requirements-py2.txt	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/requirements-py2.txt	2020-03-03 02:59:56.000000000 +0000
@@ -6,4 +6,3 @@ simplejson>=3.6.3
 
 # Development
 mock>=1.3.0
-unittest2==1.1.0
diff -pruN 1.0.2-2/requirements-py3.txt 1.0.5-1/requirements-py3.txt
--- 1.0.2-2/requirements-py3.txt	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/requirements-py3.txt	2020-03-03 02:59:56.000000000 +0000
@@ -1,16 +1,14 @@
 agate>=1.5.5
-# Using HEAD until agate-excel>0.2.0 is available.
-# agate-excel>=0.2.0
+# Using HEAD until agate-excel>=0.2.2 is available.
+# agate-excel>=0.2.2
 -e git+https://github.com/wireservice/agate-excel.git#egg=agateexcel
 agate-dbf>=0.2.0
-# Using HEAD until agate-sql>0.5.0 is available.
-# agate-excel>=0.2.0
--e git+https://github.com/wireservice/agate-sql.git#egg=agatesql
+agate-sql>=0.5.2
 six>=1.6.1
 
 # Development
-coverage>=3.5.1b1
+coverage>=4.4.2
 nose>=1.1.2
 sphinx>=1.0.7
 sphinx_rtd_theme
-tox>=1.3
+tox>=3.1.0
diff -pruN 1.0.2-2/setup.py 1.0.5-1/setup.py
--- 1.0.2-2/setup.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/setup.py	2020-03-03 02:59:56.000000000 +0000
@@ -4,10 +4,10 @@ import sys
 from setuptools import setup
 
 install_requires = [
-    'agate>=1.6.0',
-    'agate-excel>=0.2.1',
+    'agate>=1.6.1',
+    'agate-excel>=0.2.2',
     'agate-dbf>=0.2.0',
-    'agate-sql>=0.5.2',
+    'agate-sql>=0.5.3',
     'six>=1.6.1'
 ]
 
@@ -18,12 +18,15 @@ if sys.version_info < (2, 7):
 
 setup(
     name='csvkit',
-    version='1.0.2',
+    version='1.0.5',
     description='A suite of command-line tools for working with CSV, the king of tabular file formats.',
     long_description=open('README.rst').read(),
     author='Christopher Groskopf',
     author_email='chrisgroskopf@gmail.com',
-    url='http://csvkit.rtfd.org/',
+    url='https://github.com/wireservice/csvkit',
+    project_urls={
+        'Documentation': 'https://csvkit.readthedocs.io/en/latest/',
+    },
     license='MIT',
     classifiers=[
         'Development Status :: 5 - Production/Stable',
@@ -36,10 +39,9 @@ setup(
         'Operating System :: OS Independent',
         'Programming Language :: Python',
         'Programming Language :: Python :: 2.7',
-        'Programming Language :: Python :: 3.3',
-        'Programming Language :: Python :: 3.4',
         'Programming Language :: Python :: 3.5',
         'Programming Language :: Python :: 3.6',
+        'Programming Language :: Python :: 3.7',
         'Programming Language :: Python :: Implementation :: CPython',
         'Programming Language :: Python :: Implementation :: PyPy',
         'Topic :: Scientific/Engineering :: Information Analysis',
diff -pruN 1.0.2-2/tests/test_cleanup.py 1.0.5-1/tests/test_cleanup.py
--- 1.0.2-2/tests/test_cleanup.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_cleanup.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,9 +1,6 @@
 #!/usr/bin/env python
 
-try:
-    import unittest2 as unittest
-except ImportError:
-    import unittest
+import unittest
 
 from csvkit.cleanup import join_rows
 
diff -pruN 1.0.2-2/tests/test_cli.py 1.0.5-1/tests/test_cli.py
--- 1.0.2-2/tests/test_cli.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_cli.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,9 +1,6 @@
 #!/usr/bin/env python
 
-try:
-    import unittest2 as unittest
-except ImportError:
-    import unittest
+import unittest
 
 from csvkit.cli import match_column_identifier, parse_column_identifiers
 
diff -pruN 1.0.2-2/tests/test_convert/test_convert.py 1.0.5-1/tests/test_convert/test_convert.py
--- 1.0.2-2/tests/test_convert/test_convert.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_convert/test_convert.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,9 +1,6 @@
 #!/usr/bin/env python
 
-try:
-    import unittest2 as unittest
-except ImportError:
-    import unittest
+import unittest
 
 from csvkit import convert
 
diff -pruN 1.0.2-2/tests/test_grep.py 1.0.5-1/tests/test_grep.py
--- 1.0.2-2/tests/test_grep.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_grep.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,11 +1,7 @@
 #!/usr/bin/env python
 
 import re
-
-try:
-    import unittest2 as unittest
-except ImportError:
-    import unittest
+import unittest
 
 from csvkit.grep import FilteringCSVReader
 from csvkit.exceptions import ColumnIdentifierError
diff -pruN 1.0.2-2/tests/test_utilities/test_csvclean.py 1.0.5-1/tests/test_utilities/test_csvclean.py
--- 1.0.2-2/tests/test_utilities/test_csvclean.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvclean.py	2020-03-03 02:59:56.000000000 +0000
@@ -100,6 +100,13 @@ class TestCSVClean(CSVKitTestCase, Empty
             '4,5,©\n',
         ], [], ['-e', 'latin1'])
 
+    def test_removes_bom(self):
+        self.assertCleaned('test_utf8_bom', [
+            'foo,bar,baz\n',
+            '1,2,3\n',
+            '4,5,ʤ\n',
+        ], [], [])
+
     def test_dry_run(self):
         output = self.get_output_as_io(['-n', 'examples/bad.csv'])
         self.assertFalse(os.path.exists('examples/bad_err.csv'))
diff -pruN 1.0.2-2/tests/test_utilities/test_csvcut.py 1.0.5-1/tests/test_utilities/test_csvcut.py
--- 1.0.2-2/tests/test_utilities/test_csvcut.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvcut.py	2020-03-03 02:59:56.000000000 +0000
@@ -62,6 +62,12 @@ class TestCSVCut(CSVKitTestCase, Columns
             ['1'],
         ])
 
+    def test_delete_empty(self):
+        self.assertRows(['-c', 'column_c', '--delete-empty-rows', 'examples/bad.csv'], [
+            ['column_c'],
+            ['17'],
+        ])
+
     def test_no_header_row(self):
         self.assertRows(['-c', '2', '--no-header-row', 'examples/no_header_row.csv'], [
             ['b'],
@@ -71,3 +77,17 @@ class TestCSVCut(CSVKitTestCase, Columns
     def test_ragged(self):
         # Test that csvcut doesn't error when a row is short.
         self.get_output(['-c', 'column_c', 'examples/bad.csv'])
+
+    def test_truncate(self):
+        # Test that csvcut truncates long rows.
+        self.assertRows(['-C', 'column_a,column_b', '--delete-empty-rows', 'examples/bad.csv'], [
+            ['column_c'],
+            ['17'],
+        ])
+
+    def test_names_with_skip_lines(self):
+        self.assertLines(['--names', '--skip-lines', '3', 'examples/test_skip_lines.csv'], [
+            '  1: a',
+            '  2: b',
+            '  3: c',
+        ])
diff -pruN 1.0.2-2/tests/test_utilities/test_csvformat.py 1.0.5-1/tests/test_utilities/test_csvformat.py
--- 1.0.2-2/tests/test_utilities/test_csvformat.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvformat.py	2020-03-03 02:59:56.000000000 +0000
@@ -27,6 +27,17 @@ class TestCSVFormat(CSVKitTestCase, Empt
             '1|2|3',
         ])
 
+    def test_no_header_row(self):
+        self.assertLines(['--no-header-row', 'examples/no_header_row.csv'], [
+            '1,2,3',
+        ])
+
+    def test_linenumbers(self):
+        self.assertLines(['--linenumbers', 'examples/dummy.csv'], [
+            'line_number,a,b,c',
+            '1,1,2,3',
+        ])
+
     def test_delimiter(self):
         self.assertLines(['-D', '|', 'examples/dummy.csv'], [
             'a|b|c',
diff -pruN 1.0.2-2/tests/test_utilities/test_csvgrep.py 1.0.5-1/tests/test_utilities/test_csvgrep.py
--- 1.0.2-2/tests/test_utilities/test_csvgrep.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvgrep.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,4 +1,5 @@
 #!/usr/bin/env python
+# -*- coding: utf-8 -*-
 
 import sys
 
@@ -32,6 +33,24 @@ class TestCSVGrep(CSVKitTestCase, Column
             ['1', '2', '3'],
         ])
 
+    def test_any_match(self):
+        self.assertRows(['-c', '1,2,3', '-a', '-m', '1', 'examples/dummy.csv'], [
+            ['a', 'b', 'c'],
+            ['1', '2', '3'],
+        ])
+
+    def test_match_utf8(self):
+        self.assertRows(['-c', '3', '-m', 'ʤ', 'examples/test_utf8.csv'], [
+            ['foo', 'bar', 'baz'],
+            ['4', '5', u'ʤ'],
+        ])
+
+    def test_match_utf8_bom(self):
+        self.assertRows(['-c', '3', '-m', 'ʤ', 'examples/test_utf8_bom.csv'], [
+            ['foo', 'bar', 'baz'],
+            ['4', '5', u'ʤ'],
+        ])
+
     def test_no_match(self):
         self.assertRows(['-c', '1', '-m', 'NO MATCH', 'examples/dummy.csv'], [
             ['a', 'b', 'c'],
@@ -49,6 +68,12 @@ class TestCSVGrep(CSVKitTestCase, Column
             ['1', '2', '3'],
         ])
 
+    def test_re_match_utf8(self):
+        self.assertRows(['-c', '3', '-r', 'ʤ', 'examples/test_utf8.csv'], [
+            ['foo', 'bar', 'baz'],
+            ['4', '5', u'ʤ'],
+        ])
+
     def test_string_match(self):
         self.assertRows(['-c', '1', '-m', 'ILLINOIS', 'examples/realdata/FY09_EDU_Recipients_by_State.csv'], [
             ['State Name', 'State Abbreviate', 'Code', 'Montgomery GI Bill-Active Duty', 'Montgomery GI Bill- Selective Reserve', 'Dependents\' Educational Assistance', 'Reserve Educational Assistance Program', 'Post-Vietnam Era Veteran\'s Educational Assistance Program', 'TOTAL', ''],
diff -pruN 1.0.2-2/tests/test_utilities/test_csvjoin.py 1.0.5-1/tests/test_utilities/test_csvjoin.py
--- 1.0.2-2/tests/test_utilities/test_csvjoin.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvjoin.py	2020-03-03 02:59:56.000000000 +0000
@@ -44,6 +44,12 @@ class TestCSVJoin(CSVKitTestCase, EmptyF
         with open('examples/join_short.csv') as f:
             self.assertEqual(output.readlines(), f.readlines())
 
+    def test_single(self):
+        self.assertRows(['examples/dummy.csv', '--no-inference'], [
+            ['a', 'b', 'c'],
+            ['1', '2', '3'],
+        ])
+
     def test_no_blanks(self):
         self.assertRows(['examples/blanks.csv', 'examples/blanks.csv'], [
             ['a', 'b', 'c', 'd', 'e', 'f', 'a2', 'b2', 'c2', 'd2', 'e2', 'f2'],
diff -pruN 1.0.2-2/tests/test_utilities/test_csvjson.py 1.0.5-1/tests/test_utilities/test_csvjson.py
--- 1.0.2-2/tests/test_utilities/test_csvjson.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvjson.py	2020-03-03 02:59:56.000000000 +0000
@@ -30,6 +30,14 @@ class TestCSVJSON(CSVKitTestCase, EmptyF
         js = json.loads(self.get_output(['examples/sniff_limit.csv']))
         self.assertDictEqual(js[0], {'a': True, 'c': 3.0, 'b': 2.0})
 
+    def test_tsv(self):
+        js = json.loads(self.get_output(['examples/dummy.tsv']))
+        self.assertDictEqual(js[0], {'a': True, 'c': 3.0, 'b': 2.0})
+
+    def test_tsv_streaming(self):
+        js = json.loads(self.get_output(['--stream', '--no-inference', '--snifflimit', '0', '--tabs', 'examples/dummy.tsv']))
+        self.assertDictEqual(js, {'a': '1', 'c': '3', 'b': '2'})
+
     def test_no_blanks(self):
         js = json.loads(self.get_output(['examples/blanks.csv']))
         self.assertDictEqual(js[0], {'a': None, 'b': None, 'c': None, 'd': None, 'e': None, 'f': None})
@@ -50,68 +58,100 @@ class TestCSVJSON(CSVKitTestCase, EmptyF
         output = self.get_output(['-i', '4', 'examples/dummy.csv'])
         js = json.loads(output)
         self.assertDictEqual(js[0], {'a': True, 'c': 3.0, 'b': 2.0})
-        self.assertRegex(output, '        "a": true,')
+        six.assertRegex(self, output, '        "a": true,')
 
     def test_keying(self):
         js = json.loads(self.get_output(['-k', 'a', 'examples/dummy.csv']))
-        self.assertDictEqual(js, {'true': {'a': True, 'c': 3.0, 'b': 2.0}})
+        self.assertDictEqual(js, {'True': {'a': True, 'c': 3.0, 'b': 2.0}})
 
     def test_duplicate_keys(self):
         output_file = six.StringIO()
         utility = CSVJSON(['-k', 'a', 'examples/dummy3.csv'], output_file)
-        self.assertRaisesRegex(ValueError, 'Value True is not unique in the key column.', utility.run)
+        six.assertRaisesRegex(self, ValueError,
+                              'Value True is not unique in the key column.',
+                              utility.run)
         output_file.close()
 
-    def test_geojson(self):
-        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', 'examples/test_geo.csv']))
+    def test_geojson_with_id(self):
+        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '-k', 'slug', 'examples/test_geo.csv']))
 
         self.assertEqual(geojson['type'], 'FeatureCollection')
-        self.assertFalse('crs' in geojson)
+        self.assertNotIn('crs', geojson)
         self.assertEqual(geojson['bbox'], [-95.334619, 32.299076986939205, -95.250699, 32.351434])
         self.assertEqual(len(geojson['features']), 17)
 
         for feature in geojson['features']:
             self.assertEqual(feature['type'], 'Feature')
-            self.assertFalse('id' in feature)
-            self.assertEqual(len(feature['properties']), 10)
+            self.assertIn('id', feature)
+            self.assertIn('properties', feature)
+            self.assertIsInstance(feature['properties'], dict)
+            self.assertGreater(len(feature['properties']), 1)
 
             geometry = feature['geometry']
 
             self.assertEqual(len(geometry['coordinates']), 2)
-            self.assertTrue(isinstance(geometry['coordinates'][0], float))
-            self.assertTrue(isinstance(geometry['coordinates'][1], float))
+            self.assertIsInstance(geometry['coordinates'][0], float)
+            self.assertIsInstance(geometry['coordinates'][1], float)
 
-    def test_geojson_with_id(self):
-        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '-k', 'slug', 'examples/test_geo.csv']))
+    def test_geojson_point(self):
+        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', 'examples/test_geo.csv']))
 
         self.assertEqual(geojson['type'], 'FeatureCollection')
-        self.assertFalse('crs' in geojson)
+        self.assertNotIn('crs', geojson)
         self.assertEqual(geojson['bbox'], [-95.334619, 32.299076986939205, -95.250699, 32.351434])
         self.assertEqual(len(geojson['features']), 17)
 
         for feature in geojson['features']:
             self.assertEqual(feature['type'], 'Feature')
-            self.assertTrue('id' in feature)
-            self.assertEqual(len(feature['properties']), 9)
+            self.assertNotIn('id', feature)
+            self.assertIn('properties', feature)
+            self.assertIsInstance(feature['properties'], dict)
+            self.assertGreater(len(feature['properties']), 1)
 
             geometry = feature['geometry']
 
             self.assertEqual(len(geometry['coordinates']), 2)
-            self.assertTrue(isinstance(geometry['coordinates'][0], float))
-            self.assertTrue(isinstance(geometry['coordinates'][1], float))
+            self.assertIsInstance(geometry['coordinates'][0], float)
+            self.assertIsInstance(geometry['coordinates'][1], float)
 
-    def test_geojson_with_crs(self):
-        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '--crs', 'EPSG:4269', 'examples/test_geo.csv']))
+    def test_geojson_shape(self):
+        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '--type', 'type', '--geometry', 'geojson', 'examples/test_geojson.csv']))
 
         self.assertEqual(geojson['type'], 'FeatureCollection')
-        self.assertTrue('crs' in geojson)
-        self.assertEqual(geojson['bbox'], [-95.334619, 32.299076986939205, -95.250699, 32.351434])
-        self.assertEqual(len(geojson['features']), 17)
+        self.assertNotIn('crs', geojson)
+        self.assertEqual(geojson['bbox'], [100.0, 0.0, 105.0, 1.0])
+        self.assertEqual(len(geojson['features']), 3)
 
-        crs = geojson['crs']
+        for feature in geojson['features']:
+            self.assertEqual(feature['type'], 'Feature')
+            self.assertNotIn('id', feature)
+            self.assertIn('properties', feature)
+            self.assertIsInstance(feature['properties'], dict)
+            self.assertIn('prop0', feature['properties'].keys())
+
+            geometry = feature['geometry']
 
-        self.assertEqual(crs['type'], 'name')
-        self.assertEqual(crs['properties']['name'], 'EPSG:4269')
+            self.assertIn('coordinates', geometry)
+            self.assertIsNotNone(geometry['coordinates'])
+
+        self.assertEqual(geojson['features'][0]['geometry']['type'], 'Point')
+        self.assertEqual(geojson['features'][1]['geometry']['type'], 'LineString')
+        self.assertEqual(geojson['features'][2]['geometry']['type'], 'Polygon')
+
+        self.assertEqual(geojson['features'][0]['geometry']['coordinates'], [102.0, 0.5])
+        self.assertEqual(geojson['features'][1]['geometry']['coordinates'],
+                         [[102.0, 0.0], [103.0, 1.0], [104.0, 0.0], [105.0, 1.0]])
+        self.assertEqual(geojson['features'][2]['geometry']['coordinates'],
+                         [[[100.0, 0.0], [101.0, 0.0], [101.0, 1.0], [100.0, 1.0], [100.0, 0.0]]])
+
+    def test_geojson_with_crs(self):
+        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '--crs', 'EPSG:4269', 'examples/test_geo.csv']))
+        self.assertIn('crs', geojson)
+        self.assertEqual(geojson['crs'], {'type': 'name', 'properties': {'name': 'EPSG:4269'}})
+
+    def test_geojson_with_no_bbox(self):
+        geojson = json.loads(self.get_output(['--lat', 'latitude', '--lon', 'longitude', '--no-bbox', 'examples/test_geo.csv']))
+        self.assertNotIn('bbox', geojson)
 
     def test_ndjson(self):
         self.assertLines(['--stream', 'examples/testjson_converted.csv'], [
@@ -122,11 +162,55 @@ class TestCSVJSON(CSVKitTestCase, EmptyF
             '{"text": "Unicode! Σ", "float": null, "datetime": null, "boolean": null, "time": null, "date": null, "integer": null}',
         ])
 
-    def test_ndjson_with_no_inference(self):
-        self.assertLines(['--stream', '--no-inference', 'examples/testjson_converted.csv'], [
+    def test_ndjson_streaming(self):
+        self.assertLines(['--stream', '--no-inference', '--snifflimit', '0', 'examples/testjson_converted.csv'], [
             '{"text": "Chicago Reader", "float": "1.0", "datetime": "1971-01-01T04:14:00", "boolean": "True", "time": "4:14:00", "date": "1971-01-01", "integer": "40"}',
             '{"text": "Chicago Sun-Times", "float": "1.27", "datetime": "1948-01-01T14:57:13", "boolean": "True", "time": "14:57:13", "date": "1948-01-01", "integer": "63"}',
             '{"text": "Chicago Tribune", "float": "41800000.01", "datetime": "1920-01-01T00:00:00", "boolean": "False", "time": "0:00:00", "date": "1920-01-01", "integer": "164"}',
             '{"text": "This row has blanks", "float": "", "datetime": "", "boolean": "", "time": "", "date": "", "integer": ""}',
             '{"text": "Unicode! Σ", "float": "", "datetime": "", "boolean": "", "time": "", "date": "", "integer": ""}',
         ])
+
+    def test_ndgeojson(self):
+        self.maxDiff = 5000
+        self.assertLines(['--lat', 'latitude', '--lon', 'longitude', '--stream', 'examples/test_geo.csv'], [
+            '{"type": "Feature", "properties": {"slug": "dcl", "title": "Downtown Coffee Lounge", "description": "In addition to being the only coffee shop in downtown Tyler, DCL also features regular exhibitions of work by local artists.", "address": "200 West Erwin Street", "type": "Gallery", "last_seen_date": "2012-03-30"}, "geometry": {"type": "Point", "coordinates": [-95.30181, 32.35066]}}',
+            '{"type": "Feature", "properties": {"slug": "tyler-museum", "title": "Tyler Museum of Art", "description": "The Tyler Museum of Art on the campus of Tyler Junior College is the largest art museum in Tyler. Visit them online at <a href=\\"http://www.tylermuseum.org/\\">http://www.tylermuseum.org/</a>.", "address": "1300 South Mahon Avenue", "type": "Museum", "last_seen_date": "2012-04-02"}, "geometry": {"type": "Point", "coordinates": [-95.28174, 32.33396]}}',
+            '{"type": "Feature", "properties": {"slug": "genecov", "title": "Genecov Sculpture", "description": "Stainless Steel Sculpture", "address": "1350 Dominion Plaza", "type": "Sculpture", "photo_url": "http://i.imgur.com/DICdn.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-04"}, "geometry": {"type": "Point", "coordinates": [-95.31571447849274, 32.299076986939205]}}',
+            '{"type": "Feature", "properties": {"slug": "gallery-main-street", "title": "Gallery Main Street", "description": "The only dedicated art gallery in Tyler. Visit them online at <a href=\\"http://www.heartoftyler.com/downtowntylerarts/\\">http://www.heartoftyler.com/downtowntylerarts/</a>.", "address": "110 West Erwin Street", "type": "Gallery", "last_seen_date": "2012-04-09"}, "geometry": {"type": "Point", "coordinates": [-95.30123, 32.35066]}}',
+            '{"type": "Feature", "properties": {"slug": "spirit-of-progress", "title": "The Spirit of Progress", "address": "100 block of North Spring Avenue", "type": "Relief", "photo_url": "http://media.hacktyler.com/artmap/photos/spirit-of-progress.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "2012-04-11"}, "geometry": {"type": "Point", "coordinates": [-95.2995, 32.3513]}}',
+            '{"type": "Feature", "properties": {"slug": "celestial-conversations-2", "title": "Celestial Conversations #2", "artist": "Simon Saleh", "description": "Steel Sculpture", "address": "100 block of North Spring Avenue", "type": "Sculpture", "photo_url": "http://media.hacktyler.com/artmap/photos/celestial-conversations-2.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "2012-04-11"}, "geometry": {"type": "Point", "coordinates": [-95.2995, 32.351]}}',
+            '{"type": "Feature", "properties": {"slug": "pivot-bounce", "title": "Pivot Bounce", "artist": "Chelsea Cope", "address": "100 block of North Spring Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/pmxyi.jpg?1", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-11"}, "geometry": {"type": "Point", "coordinates": [-95.29944, 32.351434]}}',
+            '{"type": "Feature", "properties": {"slug": "children-of-peace", "title": "Children of Peace", "artist": "Gary Price", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/rUikO.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.300222, 32.339826]}}',
+            '{"type": "Feature", "properties": {"slug": "ross-bears", "title": "Ross\' Bears", "description": "Granite Sculpture", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/SpJQI.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.300034, 32.339776]}}',
+            '{"type": "Feature", "properties": {"slug": "butterfly-garden", "title": "Butterfly Garden", "description": "Cast Bronze", "type": "Sculpture", "photo_url": "http://i.imgur.com/0L8DF.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.300219, 32.339559]}}',
+            '{"type": "Feature", "properties": {"slug": "goose-fountain", "title": "TJC Goose Fountain", "description": "Copper (?) Sculpture", "address": "1300 S. Mahon Ave.", "type": "Sculpture", "photo_url": "http://i.imgur.com/UWfS6.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.28263, 32.333944]}}',
+            '{"type": "Feature", "properties": {"slug": "tjc-cement-totems", "description": "Cast Cement Totems", "address": "1300 S. Mahon Ave.", "type": "Sculpture", "photo_url": "http://i.imgur.com/lRmYd.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.283894, 32.333899]}}',
+            '{"type": "Feature", "properties": {"slug": "alison", "title": "Alison", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/7OcrG.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.299887, 32.339809]}}',
+            '{"type": "Feature", "properties": {"slug": "jackson", "title": "Jackson", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/aQJfv.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.299939, 32.339828]}}',
+            '{"type": "Feature", "properties": {"slug": "505-third", "title": "Untitled", "description": "Stainless Steel", "address": "505 Third St.", "type": "Sculpture", "photo_url": "http://i.imgur.com/0moUY.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.305429, 32.333082]}}',
+            '{"type": "Feature", "properties": {"slug": "obeidder", "title": "Obeidder Monster", "description": "Sharpie and Spray Paint", "address": "3319 Seaton St.", "type": "Street Art", "photo_url": "http://i.imgur.com/3aX7E.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "2012-04-15"}, "geometry": {"type": "Point", "coordinates": [-95.334619, 32.314431]}}',
+            '{"type": "Feature", "properties": {"slug": "sensor-device", "title": "Sensor Device", "artist": "Kurt Dyrhaug", "address": "University of Texas, Campus Drive", "type": "Sculpture", "photo_url": "http://media.hacktyler.com/artmap/photos/sensor-device.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "2012-04-16"}, "geometry": {"type": "Point", "coordinates": [-95.250699, 32.317216]}}'
+        ])
+
+    def test_ndgeojson_streaming(self):
+        self.maxDiff = 5000
+        self.assertLines(['--stream', '--no-inference', '--snifflimit', '0', '--lat', 'latitude', '--lon', 'longitude', '--stream', 'examples/test_geo.csv'], [
+            '{"type": "Feature", "properties": {"slug": "dcl", "title": "Downtown Coffee Lounge", "description": "In addition to being the only coffee shop in downtown Tyler, DCL also features regular exhibitions of work by local artists.", "address": "200 West Erwin Street", "type": "Gallery", "last_seen_date": "3/30/12"}, "geometry": {"type": "Point", "coordinates": [-95.30181, 32.35066]}}',
+            '{"type": "Feature", "properties": {"slug": "tyler-museum", "title": "Tyler Museum of Art", "description": "The Tyler Museum of Art on the campus of Tyler Junior College is the largest art museum in Tyler. Visit them online at <a href=\\"http://www.tylermuseum.org/\\">http://www.tylermuseum.org/</a>.", "address": "1300 South Mahon Avenue", "type": "Museum", "last_seen_date": "4/2/12"}, "geometry": {"type": "Point", "coordinates": [-95.28174, 32.33396]}}',
+            '{"type": "Feature", "properties": {"slug": "genecov", "title": "Genecov Sculpture", "description": "Stainless Steel Sculpture", "address": "1350 Dominion Plaza", "type": "Sculpture", "photo_url": "http://i.imgur.com/DICdn.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/4/12"}, "geometry": {"type": "Point", "coordinates": [-95.31571447849274, 32.299076986939205]}}',
+            '{"type": "Feature", "properties": {"slug": "gallery-main-street", "title": "Gallery Main Street", "description": "The only dedicated art gallery in Tyler. Visit them online at <a href=\\"http://www.heartoftyler.com/downtowntylerarts/\\">http://www.heartoftyler.com/downtowntylerarts/</a>.", "address": "110 West Erwin Street", "type": "Gallery", "last_seen_date": "4/9/12"}, "geometry": {"type": "Point", "coordinates": [-95.30123, 32.35066]}}',
+            '{"type": "Feature", "properties": {"slug": "spirit-of-progress", "title": "The Spirit of Progress", "address": "100 block of North Spring Avenue", "type": "Relief", "photo_url": "http://media.hacktyler.com/artmap/photos/spirit-of-progress.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "4/11/12"}, "geometry": {"type": "Point", "coordinates": [-95.2995, 32.3513]}}',
+            '{"type": "Feature", "properties": {"slug": "celestial-conversations-2", "title": "Celestial Conversations #2", "artist": "Simon Saleh", "description": "Steel Sculpture", "address": "100 block of North Spring Avenue", "type": "Sculpture", "photo_url": "http://media.hacktyler.com/artmap/photos/celestial-conversations-2.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "4/11/12"}, "geometry": {"type": "Point", "coordinates": [-95.2995, 32.351]}}',
+            '{"type": "Feature", "properties": {"slug": "pivot-bounce", "title": "Pivot Bounce", "artist": "Chelsea Cope", "address": "100 block of North Spring Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/pmxyi.jpg?1", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/11/12"}, "geometry": {"type": "Point", "coordinates": [-95.29944, 32.351434]}}',
+            '{"type": "Feature", "properties": {"slug": "children-of-peace", "title": "Children of Peace", "artist": "Gary Price", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/rUikO.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.300222, 32.339826]}}',
+            '{"type": "Feature", "properties": {"slug": "ross-bears", "title": "Ross\' Bears", "description": "Granite Sculpture", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/SpJQI.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.300034, 32.339776]}}',
+            '{"type": "Feature", "properties": {"slug": "butterfly-garden", "title": "Butterfly Garden", "description": "Cast Bronze", "type": "Sculpture", "photo_url": "http://i.imgur.com/0L8DF.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.300219, 32.339559]}}',
+            '{"type": "Feature", "properties": {"slug": "goose-fountain", "title": "TJC Goose Fountain", "description": "Copper (?) Sculpture", "address": "1300 S. Mahon Ave.", "type": "Sculpture", "photo_url": "http://i.imgur.com/UWfS6.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.28263, 32.333944]}}',
+            '{"type": "Feature", "properties": {"slug": "tjc-cement-totems", "description": "Cast Cement Totems", "address": "1300 S. Mahon Ave.", "type": "Sculpture", "photo_url": "http://i.imgur.com/lRmYd.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.283894, 32.333899]}}',
+            '{"type": "Feature", "properties": {"slug": "alison", "title": "Alison", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/7OcrG.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.299887, 32.339809]}}',
+            '{"type": "Feature", "properties": {"slug": "jackson", "title": "Jackson", "description": "Cast Bronze", "address": "900 South Broadway Avenue", "type": "Sculpture", "photo_url": "http://i.imgur.com/aQJfv.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.299939, 32.339828]}}',
+            '{"type": "Feature", "properties": {"slug": "505-third", "title": "Untitled", "description": "Stainless Steel", "address": "505 Third St.", "type": "Sculpture", "photo_url": "http://i.imgur.com/0moUY.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.305429, 32.333082]}}',
+            '{"type": "Feature", "properties": {"slug": "obeidder", "title": "Obeidder Monster", "description": "Sharpie and Spray Paint", "address": "3319 Seaton St.", "type": "Street Art", "photo_url": "http://i.imgur.com/3aX7E.jpg", "photo_credit": "Photo by Justin Edwards. Used with permission.", "last_seen_date": "4/15/12"}, "geometry": {"type": "Point", "coordinates": [-95.334619, 32.314431]}}',
+            '{"type": "Feature", "properties": {"slug": "sensor-device", "title": "Sensor Device", "artist": "Kurt Dyrhaug", "address": "University of Texas, Campus Drive", "type": "Sculpture", "photo_url": "http://media.hacktyler.com/artmap/photos/sensor-device.jpg", "photo_credit": "Photo by Christopher Groskopf. Used with permission.", "last_seen_date": "4/16/12"}, "geometry": {"type": "Point", "coordinates": [-95.250699, 32.317216]}}'
+        ])
diff -pruN 1.0.2-2/tests/test_utilities/test_csvlook.py 1.0.5-1/tests/test_utilities/test_csvlook.py
--- 1.0.2-2/tests/test_utilities/test_csvlook.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvlook.py	2020-03-03 02:59:56.000000000 +0000
@@ -22,10 +22,26 @@ class TestCSVLook(CSVKitTestCase, EmptyF
             launch_new_instance()
 
     def test_runs(self):
-        self.get_output(['examples/test_utf8.csv'])
+        if sys.version_info < (3,):
+            self.get_output(['examples/test_utf8.csv'])
+        else:
+            self.assertLines(['examples/test_utf8.csv'], [
+                '| foo | bar | baz |',
+                '| --- | --- | --- |',
+                '|   1 |   2 | 3   |',
+                '|   4 |   5 | ʤ   |',
+            ])
 
     def test_encoding(self):
-        self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
+        if sys.version_info < (3,):
+            self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
+        else:
+            self.assertLines(['-e', 'latin1', 'examples/test_latin1.csv'], [
+                '| a | b | c |',
+                '| - | - | - |',
+                '| 1 | 2 | 3 |',
+                '| 4 | 5 | © |',
+            ])
 
     def test_simple(self):
         self.assertLines(['examples/dummy3.csv'], [
@@ -62,6 +78,14 @@ class TestCSVLook(CSVKitTestCase, EmptyF
             '| foo | bar | baz |',
             '| --- | --- | --- |',
             '|   1 |   2 | 3   |',
+            u'|   4 |   5 | ʤ   |',
+        ])
+
+    def test_unicode_bom(self):
+        self.assertLines(['examples/test_utf8_bom.csv'], [
+            '| foo | bar | baz |',
+            '| --- | --- | --- |',
+            '|   1 |   2 | 3   |',
             u'|   4 |   5 | ʤ   |',
         ])
 
diff -pruN 1.0.2-2/tests/test_utilities/test_csvsort.py 1.0.5-1/tests/test_utilities/test_csvsort.py
--- 1.0.2-2/tests/test_utilities/test_csvsort.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvsort.py	2020-03-03 02:59:56.000000000 +0000
@@ -22,10 +22,24 @@ class TestCSVSort(CSVKitTestCase, Column
             launch_new_instance()
 
     def test_runs(self):
-        self.get_output(['examples/test_utf8.csv'])
+        if sys.version_info < (3,):
+            self.get_output(['examples/test_utf8.csv'])
+        else:
+            self.assertRows(['examples/test_utf8.csv'], [
+                ['foo', 'bar', 'baz'],
+                ['1', '2', '3'],
+                ['4', '5', 'ʤ'],
+            ])
 
     def test_encoding(self):
-        self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
+        if sys.version_info < (3,):
+            self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
+        else:
+            self.assertRows(['-e', 'latin1', 'examples/test_latin1.csv'], [
+                ['a', 'b', 'c'],
+                ['1', '2', '3'],
+                ['4', '5', '©'],
+            ])
 
     def test_sort_string_reverse(self):
         reader = self.get_output_as_reader(['-c', '1', '-r', 'examples/testxls_converted.csv'])
@@ -40,9 +54,6 @@ class TestCSVSort(CSVKitTestCase, Column
         self.assertEqual(test_order, new_order)
 
     def test_no_blanks(self):
-        pass
-
-    def test_blanks(self):
         reader = self.get_output_as_reader(['examples/blanks.csv'])
         test_order = [
             ['a', 'b', 'c', 'd', 'e', 'f'],
@@ -51,7 +62,7 @@ class TestCSVSort(CSVKitTestCase, Column
         new_order = [r for r in reader]
         self.assertEqual(test_order, new_order)
 
-    def test_no_header_row(self):
+    def test_blanks(self):
         reader = self.get_output_as_reader(['--blanks', 'examples/blanks.csv'])
         test_order = [
             ['a', 'b', 'c', 'd', 'e', 'f'],
@@ -60,6 +71,12 @@ class TestCSVSort(CSVKitTestCase, Column
         new_order = [r for r in reader]
         self.assertEqual(test_order, new_order)
 
+    def test_no_header_row(self):
+        self.assertRows(['--no-header-row', '--no-inference', 'examples/no_header_row.csv'], [
+            ['a', 'b', 'c'],
+            ['1', '2', '3'],
+        ])
+
     def test_no_inference(self):
         reader = self.get_output_as_reader(['--no-inference', '-c', '1', 'examples/test_literal_order.csv'])
         test_order = [u'a', u'192', u'27', u'3']
diff -pruN 1.0.2-2/tests/test_utilities/test_csvsql.py 1.0.5-1/tests/test_utilities/test_csvsql.py
--- 1.0.2-2/tests/test_utilities/test_csvsql.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvsql.py	2020-03-03 02:59:56.000000000 +0000
@@ -5,8 +5,7 @@ import os
 import sys
 
 import six
-from sqlalchemy import Index, MetaData, Table, create_engine
-from sqlalchemy.exc import OperationalError
+from sqlalchemy.exc import IntegrityError, OperationalError
 
 try:
     from mock import patch
@@ -14,6 +13,7 @@ except ImportError:
     from unittest.mock import patch
 
 from csvkit.utilities.csvsql import CSVSQL, launch_new_instance
+from csvkit.utilities.sql2csv import SQL2CSV
 from tests.utils import CSVKitTestCase, EmptyFileTests, stdin_as_string
 
 
@@ -36,65 +36,78 @@ class TestCSVSQL(CSVKitTestCase, EmptyFi
     def test_create_table(self):
         sql = self.get_output(['--tables', 'foo', 'examples/testfixed_converted.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('text VARCHAR(17) NOT NULL' in sql)
-        self.assertTrue('date DATE' in sql)
-        self.assertTrue('integer DECIMAL' in sql)
-        self.assertTrue('boolean BOOLEAN' in sql)
-        self.assertTrue('float DECIMAL' in sql)
-        self.assertTrue('time TIMESTAMP' in sql)
-        self.assertTrue('datetime TIMESTAMP' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  text VARCHAR NOT NULL, 
+  date DATE, 
+  integer DECIMAL, 
+  boolean BOOLEAN, 
+  float DECIMAL, 
+  time DATETIME, 
+  datetime TIMESTAMP, 
+  empty_column BOOLEAN
+);
+''')  # noqa
 
     def test_no_blanks(self):
         sql = self.get_output(['--tables', 'foo', 'examples/blanks.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('a BOOLEAN' in sql)
-        self.assertTrue('b BOOLEAN' in sql)
-        self.assertTrue('c BOOLEAN' in sql)
-        self.assertTrue('d BOOLEAN' in sql)
-        self.assertTrue('e BOOLEAN' in sql)
-        self.assertTrue('f BOOLEAN' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  a BOOLEAN, 
+  b BOOLEAN, 
+  c BOOLEAN, 
+  d BOOLEAN, 
+  e BOOLEAN, 
+  f BOOLEAN
+);
+''')  # noqa
 
     def test_blanks(self):
         sql = self.get_output(['--tables', 'foo', '--blanks', 'examples/blanks.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('a VARCHAR NOT NULL' in sql)
-        self.assertTrue('b VARCHAR(2) NOT NULL' in sql)
-        self.assertTrue('c VARCHAR(3) NOT NULL' in sql)
-        self.assertTrue('d VARCHAR(4) NOT NULL' in sql)
-        self.assertTrue('e VARCHAR(4) NOT NULL' in sql)
-        self.assertTrue('f VARCHAR(1) NOT NULL' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  a VARCHAR NOT NULL, 
+  b VARCHAR NOT NULL, 
+  c VARCHAR NOT NULL, 
+  d VARCHAR NOT NULL, 
+  e VARCHAR NOT NULL, 
+  f VARCHAR NOT NULL
+);
+''')  # noqa
 
     def test_no_inference(self):
         sql = self.get_output(['--tables', 'foo', '--no-inference', 'examples/testfixed_converted.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('text VARCHAR(17) NOT NULL' in sql)
-        self.assertTrue('date VARCHAR(10)' in sql)
-        self.assertTrue('integer VARCHAR(3)' in sql)
-        self.assertTrue('boolean VARCHAR(5)' in sql)
-        self.assertTrue('float VARCHAR(11)' in sql)
-        self.assertTrue('time VARCHAR(8)' in sql)
-        self.assertTrue('datetime VARCHAR(19)' in sql)
-        self.assertTrue('empty_column VARCHAR' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  text VARCHAR NOT NULL, 
+  date VARCHAR, 
+  integer VARCHAR, 
+  boolean VARCHAR, 
+  float VARCHAR, 
+  time VARCHAR, 
+  datetime VARCHAR, 
+  empty_column VARCHAR
+);
+''')  # noqa
 
     def test_no_header_row(self):
         sql = self.get_output(['--tables', 'foo', '--no-header-row', 'examples/no_header_row.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('a BOOLEAN NOT NULL' in sql)
-        self.assertTrue('b DECIMAL NOT NULL' in sql)
-        self.assertTrue('c DECIMAL NOT NULL' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  a BOOLEAN NOT NULL, 
+  b DECIMAL NOT NULL, 
+  c DECIMAL NOT NULL
+);
+''')  # noqa
 
     def test_linenumbers(self):
         sql = self.get_output(['--tables', 'foo', '--linenumbers', 'examples/dummy.csv'])
 
-        self.assertTrue('CREATE TABLE foo' in sql)
-        self.assertTrue('a BOOLEAN NOT NULL' in sql)
-        self.assertTrue('b DECIMAL NOT NULL' in sql)
-        self.assertTrue('c DECIMAL NOT NULL' in sql)
+        self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  a BOOLEAN NOT NULL, 
+  b DECIMAL NOT NULL, 
+  c DECIMAL NOT NULL
+);
+''')  # noqa
 
     def test_stdin(self):
         input_file = six.StringIO('a,b,c\n4,2,3\n')
@@ -102,10 +115,12 @@ class TestCSVSQL(CSVKitTestCase, EmptyFi
         with stdin_as_string(input_file):
             sql = self.get_output(['--tables', 'foo'])
 
-            self.assertTrue('CREATE TABLE foo' in sql)
-            self.assertTrue('a DECIMAL NOT NULL' in sql)
-            self.assertTrue('b DECIMAL NOT NULL' in sql)
-            self.assertTrue('c DECIMAL NOT NULL' in sql)
+            self.assertEqual(sql.replace('\t', '  '), '''CREATE TABLE foo (
+  a DECIMAL NOT NULL, 
+  b DECIMAL NOT NULL, 
+  c DECIMAL NOT NULL
+);
+''')  # noqa
 
         input_file.close()
 
@@ -120,19 +135,33 @@ class TestCSVSQL(CSVKitTestCase, EmptyFi
 
         input_file.close()
 
-    def test_empty_with_query(self):
+    def test_query(self):
+        input_file = six.StringIO("a,b,c\n1,2,3\n")
+
+        with stdin_as_string(input_file):
+            sql = self.get_output(['--query', 'SELECT m.usda_id, avg(i.sepal_length) AS mean_sepal_length FROM iris '
+                                   'AS i JOIN irismeta AS m ON (i.species = m.species) GROUP BY m.species',
+                                   'examples/iris.csv', 'examples/irismeta.csv'])
+
+            self.assertTrue('usda_id,mean_sepal_length' in sql)
+            self.assertTrue('IRSE,5.00' in sql)
+            self.assertTrue('IRVE2,5.936' in sql)
+            self.assertTrue('IRVI,6.58' in sql)
+
+        input_file.close()
+
+    def test_query_empty(self):
         input_file = six.StringIO()
 
         with stdin_as_string(input_file):
-            output_file = six.StringIO()
-            utility = CSVSQL(['--query', 'select 1'], output_file)
-            utility.run()
-            output_file.close()
+            output = self.get_output(['--query', 'SELECT 1'])
+            self.assertEqual(output, '1\n1\n')
 
         input_file.close()
 
     def test_query_text(self):
-        sql = self.get_output(['--insert', '--query', "SELECT text FROM testfixed_converted WHERE text LIKE 'Chicago%'", 'examples/testfixed_converted.csv'])
+        sql = self.get_output(['--query', 'SELECT text FROM testfixed_converted WHERE text LIKE "Chicago%"',
+                               'examples/testfixed_converted.csv'])
 
         self.assertEqual(sql,
             "text\n"
@@ -147,38 +176,43 @@ class TestCSVSQL(CSVKitTestCase, EmptyFi
             "question,text\n"
             "36,©\n")
 
-    def test_query_with_prefix(self):
-        self.get_output(['--insert', '--db', 'sqlite:///' + self.db_file, 'examples/dummy.csv'])
+    def test_query_update(self):
+        sql = self.get_output(['--query', 'UPDATE dummy SET a=10 WHERE a=1', '--no-inference', 'examples/dummy.csv'])
 
-        engine = create_engine('sqlite:///' + self.db_file)
-        connection = engine.connect()
-        metadata = MetaData(connection)
-        table = Table('dummy', metadata, autoload=True, autoload_with=connection)
-        index = Index('myindex', table.c.a, unique=True)
-        index.create(bind=connection)
+        self.assertEqual(sql, '')
 
-        self.get_output(['--prefix', 'OR IGNORE', '--no-create', '--insert', '--db', 'sqlite:///' + self.db_file, 'examples/dummy.csv'])
+    def test_before_after_insert(self):
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', 'examples/dummy.csv', '--before-insert',
+                         'SELECT 1; CREATE TABLE foobar (date DATE)', '--after-insert', 'INSERT INTO dummy VALUES (0, 5, 6)'])
+
+        output_file = six.StringIO()
+        utility = SQL2CSV(['--db', 'sqlite:///' + self.db_file, '--query', 'SELECT * FROM foobar'], output_file)
+        utility.run()
+        output = output_file.getvalue()
+        output_file.close()
+        self.assertEqual(output, 'date\n')
+
+        output_file = six.StringIO()
+        utility = SQL2CSV(['--db', 'sqlite:///' + self.db_file, '--query', 'SELECT * FROM dummy'], output_file)
+        utility.run()
+        output = output_file.getvalue()
+        output_file.close()
+        self.assertEqual(output, 'a,b,c\n1,2.0,3.0\n0,5.0,6.0\n')
+
+    def test_no_prefix_unique_constraint(self):
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', 'examples/dummy.csv', '--unique-constraint', 'a'])
+        with self.assertRaises(IntegrityError):
+            self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', 'examples/dummy.csv', '--no-create'])
+
+    def test_prefix_unique_constraint(self):
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', 'examples/dummy.csv', '--unique-constraint', 'a'])
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', 'examples/dummy.csv', '--no-create', '--prefix', 'OR IGNORE'])
+
+    def test_no_create_if_not_exists(self):
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', '--tables', 'foo', 'examples/foo1.csv'])
+        with self.assertRaises(OperationalError):
+            self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', '--tables', 'foo', 'examples/foo2.csv'])
 
     def test_create_if_not_exists(self):
-        self.get_output(['--insert', '--create-if-not-exists', '--tables', 'foo', '--db', 'sqlite:///' + self.db_file, 'examples/foo1.csv'])
-        self.get_output(['--insert', '--create-if-not-exists', '--tables', 'foo', '--db', 'sqlite:///' + self.db_file, 'examples/foo2.csv'])
-
-    def test_create_if_not_exists_error(self):
-        self.get_output(['--insert', '--tables', 'foobad', '--db', 'sqlite:///' + self.db_file, 'examples/foo1.csv'])
-        try:
-            self.get_output(['--insert', '--tables', 'foobad', '--db', 'sqlite:///' + self.db_file, 'examples/foo2.csv'])
-        except OperationalError:
-            pass
-
-    def test_query(self):
-        input_file = six.StringIO("a,b,c\n1,2,3\n")
-
-        with stdin_as_string(input_file):
-            sql = self.get_output(['--query', 'SELECT m.usda_id, avg(i.sepal_length) AS mean_sepal_length FROM iris AS i JOIN irismeta AS m ON (i.species = m.species) GROUP BY m.species', 'examples/iris.csv', 'examples/irismeta.csv'])
-
-            self.assertTrue('usda_id,mean_sepal_length' in sql)
-            self.assertTrue('IRSE,5.00' in sql)
-            self.assertTrue('IRVE2,5.936' in sql)
-            self.assertTrue('IRVI,6.58' in sql)
-
-        input_file.close()
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', '--tables', 'foo', 'examples/foo1.csv'])
+        self.get_output(['--db', 'sqlite:///' + self.db_file, '--insert', '--tables', 'foo', 'examples/foo2.csv', '--create-if-not-exists'])
diff -pruN 1.0.2-2/tests/test_utilities/test_csvstat.py 1.0.5-1/tests/test_utilities/test_csvstat.py
--- 1.0.2-2/tests/test_utilities/test_csvstat.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_csvstat.py	2020-03-03 02:59:56.000000000 +0000
@@ -2,6 +2,8 @@
 
 import sys
 
+import six
+
 import agate
 
 try:
@@ -21,16 +23,18 @@ class TestCSVStat(CSVKitTestCase, Column
             launch_new_instance()
 
     def test_runs(self):
+        # Test that csvstat doesn't error on UTF-8 input.
         self.get_output(['examples/test_utf8.csv'])
 
+    def test_encoding(self):
+        # Test that csvstat doesn't error on Latin-1 input.
+        self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
+
     def test_columns(self):
         output = self.get_output(['-c', '2', 'examples/testxls_converted.csv'])
         self.assertNotIn('1. "text"', output)
         self.assertIn('2. "date"', output)
 
-    def test_encoding(self):
-        self.get_output(['-e', 'latin1', 'examples/test_latin1.csv'])
-
     def test_linenumbers(self):
         output = self.get_output(['-c', '2', '--linenumbers', 'examples/dummy.csv'])
         self.assertNotIn('1. "a"', output)
@@ -47,11 +51,11 @@ class TestCSVStat(CSVKitTestCase, Column
 
     def test_unique(self):
         output = self.get_output(['-c', 'county', 'examples/realdata/ks_1033_data.csv'])
-        self.assertRegex(output, r'Unique values:\s+73')
+        six.assertRegex(self, output, r'Unique values:\s+73')
 
     def test_max_length(self):
         output = self.get_output(['-c', 'county', 'examples/realdata/ks_1033_data.csv'])
-        self.assertRegex(output, r'Longest value:\s+12')
+        six.assertRegex(self, output, r'Longest value:\s+12')
 
     def test_freq_list(self):
         output = self.get_output(['examples/realdata/ks_1033_data.csv'])
diff -pruN 1.0.2-2/tests/test_utilities/test_in2csv.py 1.0.5-1/tests/test_utilities/test_in2csv.py
--- 1.0.2-2/tests/test_utilities/test_in2csv.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_in2csv.py	2020-03-03 02:59:56.000000000 +0000
@@ -47,12 +47,30 @@ class TestIn2CSV(CSVKitTestCase, EmptyFi
     def test_date_format(self):
         self.assertConverted('csv', 'examples/test_date_format.csv', 'examples/test_date_format_converted.csv', ['--date-format', '%d/%m/%Y'])
 
+    def test_date_format_default(self):
+        self.assertConverted('csv', 'examples/test_date_format.csv', 'examples/test_date_format.csv')
+
+    def test_numeric_date_format(self):
+        self.assertConverted('csv', 'examples/test_numeric_date_format.csv', 'examples/test_date_format_converted.csv', ['--date-format', '%Y%m%d'])
+
+    def test_numeric_date_format_default(self):
+        self.assertConverted('csv', 'examples/test_numeric_date_format.csv', 'examples/test_numeric_date_format.csv')
+
+    def test_date_like_number(self):
+        self.assertConverted('csv', 'examples/date_like_number.csv', 'examples/date_like_number.csv')
+
     def test_convert_csv(self):
         self.assertConverted('csv', 'examples/testfixed_converted.csv', 'examples/testfixed_converted.csv')
 
     def test_convert_csv_with_skip_lines(self):
         self.assertConverted('csv', 'examples/test_skip_lines.csv', 'examples/dummy.csv', ['--skip-lines', '3', '--no-inference'])
 
+    def test_convert_tsv(self):
+        self.assertConverted('csv', 'examples/dummy.tsv', 'examples/dummy.csv', ['--no-inference'])
+
+    def test_convert_tsv_streaming(self):
+        self.assertConverted('csv', 'examples/dummy.tsv', 'examples/dummy.csv', ['--no-inference', '--snifflimit', '0', '--tabs'])
+
     def test_convert_dbf(self):
         self.assertConverted('dbf', 'examples/testdbf.dbf', 'examples/testdbf_converted.csv')
 
@@ -98,12 +116,19 @@ class TestIn2CSV(CSVKitTestCase, EmptyFi
     def test_convert_xlsx_with_skip_lines(self):
         self.assertConverted('xlsx', 'examples/test_skip_lines.xlsx', 'examples/testxlsx_converted.csv', ['--skip-lines', '3'])
 
-    def test_csv_no_headers(self):
-        self.assertLines(['--no-header-row', 'examples/no_header_row.csv'], [
-            'a,b,c',
-            'True,2,3',
+    def test_names(self):
+        self.assertLines(['--names', 'examples/sheets.xlsx'], [
+            'not this one',
+            'data',
+            u'ʤ',
         ])
 
+    def test_csv_no_headers(self):
+        self.assertConverted('csv', 'examples/no_header_row.csv', 'examples/dummy.csv', ['--no-header-row', '--no-inference'])
+
+    def test_csv_no_headers_streaming(self):
+        self.assertConverted('csv', 'examples/no_header_row.csv', 'examples/dummy.csv', ['--no-header-row', '--no-inference', '--snifflimit', '0'])
+
     def test_csv_datetime_inference(self):
         input_file = six.StringIO('a\n2015-01-01T00:00:00Z')
 
diff -pruN 1.0.2-2/tests/test_utilities/test_sql2csv.py 1.0.5-1/tests/test_utilities/test_sql2csv.py
--- 1.0.2-2/tests/test_utilities/test_sql2csv.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/test_utilities/test_sql2csv.py	2020-03-03 02:59:56.000000000 +0000
@@ -45,7 +45,7 @@ class TestSQL2CSV(CSVKitTestCase, EmptyF
         if not db:
             db = 'sqlite:///' + self.db_file
 
-        args = ['--db', db, '--tables', 'foo', '--insert', csv_file]
+        args = ['--db', db, '--tables', 'foo', '--insert', csv_file, '--no-inference']
 
         utility = CSVSQL(args)
         utility.run()
@@ -56,6 +56,7 @@ class TestSQL2CSV(CSVKitTestCase, EmptyF
         return text.strip()
 
     def test_encoding(self):
+        # Test that csvstat doesn't error on Latin-1 input.
         self.get_output(['-e', 'latin1', 'examples/test.sql'])
 
     def test_query(self):
diff -pruN 1.0.2-2/tests/utils.py 1.0.5-1/tests/utils.py
--- 1.0.2-2/tests/utils.py	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tests/utils.py	2020-03-03 02:59:56.000000000 +0000
@@ -1,17 +1,32 @@
 #!/usr/bin/env python
 
+"""
+To test standard input (without piped data), run each of:
+
+* csvclean
+* csvcut -c 1
+* csvformat
+* csvgrep -c 1 -m d
+* csvjson --no-inference --stream --snifflimit 0
+* csvstack
+* in2csv --format csv --no-inference --snifflimit 0
+
+And paste:
+
+"a","b","c"
+"g","h","i"
+"d","e","f"
+
+"""
+
 import sys
+import unittest
 import warnings
 from contextlib import contextmanager
 
 import agate
 import six
 
-try:
-    import unittest2 as unittest
-except ImportError:
-    import unittest
-
 from csvkit.exceptions import ColumnIdentifierError, RequiredHeaderError
 
 
diff -pruN 1.0.2-2/tox.ini 1.0.5-1/tox.ini
--- 1.0.2-2/tox.ini	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/tox.ini	2020-03-03 02:59:56.000000000 +0000
@@ -1,5 +1,5 @@
 [tox]
-envlist = py27,pypy,py33,py34,py35,py36
+envlist = py27,py35,py36,py37
 
 [testenv]
 commands = nosetests
@@ -7,20 +7,14 @@ commands = nosetests
 [testenv:py27]
 deps = -rrequirements-py2.txt
 
-[testenv:pypy]
-deps = {[testenv:py27]deps}
-
-[testenv:py33]
-deps = -rrequirements-py3.txt
-
-[testenv:py34]
-deps = {[testenv:py33]deps}
-
 [testenv:py35]
-deps = {[testenv:py33]deps}
+deps = -rrequirements-py3.txt
 
 [testenv:py36]
-deps = {[testenv:py33]deps}
+deps = {[testenv:py35]deps}
+
+[testenv:py37]
+deps = {[testenv:py35]deps}
 
 [flake8]
 ignore=E128,E501,F403
diff -pruN 1.0.2-2/.travis.yml 1.0.5-1/.travis.yml
--- 1.0.2-2/.travis.yml	2017-04-28 18:39:38.000000000 +0000
+++ 1.0.5-1/.travis.yml	2020-03-03 02:59:56.000000000 +0000
@@ -1,16 +1,15 @@
-sudo: false
+dist: xenial
 language: python
 cache: pip
+services:
+  - postgresql
 python:
   - "2.7"
-  - "3.3"
-  - "3.4"
   - "3.5"
   - "3.6"
-  - "pypy-5.3.1"
+  - "3.7"
 install:
   - if [[ $TRAVIS_PYTHON_VERSION == 3* ]]; then pip install -r requirements-py3.txt; else pip install -r requirements-py2.txt; fi
-  - if [[ $TRAVIS_PYTHON_VERSION == "pypy-5.3.1" ]]; then pip install psycopg2cffi; else pip install psycopg2; fi
   - pip install coveralls
 before_script:
   - psql -U postgres -c 'CREATE DATABASE dummy_test'
